"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateDescribeAlarmHistory = void 0;
const CloudWatchClient_1 = require("../CloudWatchClient");
const DescribeAlarmHistoryCommand_1 = require("../commands/DescribeAlarmHistoryCommand");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new DescribeAlarmHistoryCommand_1.DescribeAlarmHistoryCommand(input), ...args);
};
async function* paginateDescribeAlarmHistory(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxRecords"] = config.pageSize;
        if (config.client instanceof CloudWatchClient_1.CloudWatchClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected CloudWatch | CloudWatchClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateDescribeAlarmHistory = paginateDescribeAlarmHistory;
