"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.paginateListMetrics = void 0;
const CloudWatchClient_1 = require("../CloudWatchClient");
const ListMetricsCommand_1 = require("../commands/ListMetricsCommand");
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListMetricsCommand_1.ListMetricsCommand(input), ...args);
};
async function* paginateListMetrics(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        if (config.client instanceof CloudWatchClient_1.CloudWatchClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected CloudWatch | CloudWatchClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
exports.paginateListMetrics = paginateListMetrics;
