import { getEndpointPlugin } from "@aws-sdk/middleware-endpoint";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeAnomalyDetectorsInputFilterSensitiveLog, DescribeAnomalyDetectorsOutputFilterSensitiveLog, } from "../models/models_0";
import { deserializeAws_queryDescribeAnomalyDetectorsCommand, serializeAws_queryDescribeAnomalyDetectorsCommand, } from "../protocols/Aws_query";
export class DescribeAnomalyDetectorsCommand extends $Command {
    constructor(input) {
        super();
        this.input = input;
    }
    static getEndpointParameterInstructions() {
        return {
            UseFIPS: { type: "builtInParams", name: "useFipsEndpoint" },
            Endpoint: { type: "builtInParams", name: "endpoint" },
            Region: { type: "builtInParams", name: "region" },
            UseDualStack: { type: "builtInParams", name: "useDualstackEndpoint" },
        };
    }
    resolveMiddleware(clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        this.middlewareStack.use(getEndpointPlugin(configuration, DescribeAnomalyDetectorsCommand.getEndpointParameterInstructions()));
        const stack = clientStack.concat(this.middlewareStack);
        const { logger } = configuration;
        const clientName = "CloudWatchClient";
        const commandName = "DescribeAnomalyDetectorsCommand";
        const handlerExecutionContext = {
            logger,
            clientName,
            commandName,
            inputFilterSensitiveLog: DescribeAnomalyDetectorsInputFilterSensitiveLog,
            outputFilterSensitiveLog: DescribeAnomalyDetectorsOutputFilterSensitiveLog,
        };
        const { requestHandler } = configuration;
        return stack.resolve((request) => requestHandler.handle(request.request, options || {}), handlerExecutionContext);
    }
    serialize(input, context) {
        return serializeAws_queryDescribeAnomalyDetectorsCommand(input, context);
    }
    deserialize(output, context) {
        return deserializeAws_queryDescribeAnomalyDetectorsCommand(output, context);
    }
}
