import { CloudWatchServiceException as __BaseException } from "./CloudWatchServiceException";
export var ActionsSuppressedBy;
(function (ActionsSuppressedBy) {
    ActionsSuppressedBy["Alarm"] = "Alarm";
    ActionsSuppressedBy["ExtensionPeriod"] = "ExtensionPeriod";
    ActionsSuppressedBy["WaitPeriod"] = "WaitPeriod";
})(ActionsSuppressedBy || (ActionsSuppressedBy = {}));
export var AlarmType;
(function (AlarmType) {
    AlarmType["CompositeAlarm"] = "CompositeAlarm";
    AlarmType["MetricAlarm"] = "MetricAlarm";
})(AlarmType || (AlarmType = {}));
export var HistoryItemType;
(function (HistoryItemType) {
    HistoryItemType["Action"] = "Action";
    HistoryItemType["ConfigurationUpdate"] = "ConfigurationUpdate";
    HistoryItemType["StateUpdate"] = "StateUpdate";
})(HistoryItemType || (HistoryItemType = {}));
export var StandardUnit;
(function (StandardUnit) {
    StandardUnit["Bits"] = "Bits";
    StandardUnit["Bits_Second"] = "Bits/Second";
    StandardUnit["Bytes"] = "Bytes";
    StandardUnit["Bytes_Second"] = "Bytes/Second";
    StandardUnit["Count"] = "Count";
    StandardUnit["Count_Second"] = "Count/Second";
    StandardUnit["Gigabits"] = "Gigabits";
    StandardUnit["Gigabits_Second"] = "Gigabits/Second";
    StandardUnit["Gigabytes"] = "Gigabytes";
    StandardUnit["Gigabytes_Second"] = "Gigabytes/Second";
    StandardUnit["Kilobits"] = "Kilobits";
    StandardUnit["Kilobits_Second"] = "Kilobits/Second";
    StandardUnit["Kilobytes"] = "Kilobytes";
    StandardUnit["Kilobytes_Second"] = "Kilobytes/Second";
    StandardUnit["Megabits"] = "Megabits";
    StandardUnit["Megabits_Second"] = "Megabits/Second";
    StandardUnit["Megabytes"] = "Megabytes";
    StandardUnit["Megabytes_Second"] = "Megabytes/Second";
    StandardUnit["Microseconds"] = "Microseconds";
    StandardUnit["Milliseconds"] = "Milliseconds";
    StandardUnit["None"] = "None";
    StandardUnit["Percent"] = "Percent";
    StandardUnit["Seconds"] = "Seconds";
    StandardUnit["Terabits"] = "Terabits";
    StandardUnit["Terabits_Second"] = "Terabits/Second";
    StandardUnit["Terabytes"] = "Terabytes";
    StandardUnit["Terabytes_Second"] = "Terabytes/Second";
})(StandardUnit || (StandardUnit = {}));
export var AnomalyDetectorStateValue;
(function (AnomalyDetectorStateValue) {
    AnomalyDetectorStateValue["PENDING_TRAINING"] = "PENDING_TRAINING";
    AnomalyDetectorStateValue["TRAINED"] = "TRAINED";
    AnomalyDetectorStateValue["TRAINED_INSUFFICIENT_DATA"] = "TRAINED_INSUFFICIENT_DATA";
})(AnomalyDetectorStateValue || (AnomalyDetectorStateValue = {}));
export var AnomalyDetectorType;
(function (AnomalyDetectorType) {
    AnomalyDetectorType["METRIC_MATH"] = "METRIC_MATH";
    AnomalyDetectorType["SINGLE_METRIC"] = "SINGLE_METRIC";
})(AnomalyDetectorType || (AnomalyDetectorType = {}));
export var ComparisonOperator;
(function (ComparisonOperator) {
    ComparisonOperator["GreaterThanOrEqualToThreshold"] = "GreaterThanOrEqualToThreshold";
    ComparisonOperator["GreaterThanThreshold"] = "GreaterThanThreshold";
    ComparisonOperator["GreaterThanUpperThreshold"] = "GreaterThanUpperThreshold";
    ComparisonOperator["LessThanLowerOrGreaterThanUpperThreshold"] = "LessThanLowerOrGreaterThanUpperThreshold";
    ComparisonOperator["LessThanLowerThreshold"] = "LessThanLowerThreshold";
    ComparisonOperator["LessThanOrEqualToThreshold"] = "LessThanOrEqualToThreshold";
    ComparisonOperator["LessThanThreshold"] = "LessThanThreshold";
})(ComparisonOperator || (ComparisonOperator = {}));
export var StateValue;
(function (StateValue) {
    StateValue["ALARM"] = "ALARM";
    StateValue["INSUFFICIENT_DATA"] = "INSUFFICIENT_DATA";
    StateValue["OK"] = "OK";
})(StateValue || (StateValue = {}));
export class ConcurrentModificationException extends __BaseException {
    constructor(opts) {
        super({
            name: "ConcurrentModificationException",
            $fault: "client",
            ...opts,
        });
        this.name = "ConcurrentModificationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ConcurrentModificationException.prototype);
        this.Message = opts.Message;
    }
}
export class DashboardInvalidInputError extends __BaseException {
    constructor(opts) {
        super({
            name: "DashboardInvalidInputError",
            $fault: "client",
            ...opts,
        });
        this.name = "DashboardInvalidInputError";
        this.$fault = "client";
        Object.setPrototypeOf(this, DashboardInvalidInputError.prototype);
        this.dashboardValidationMessages = opts.dashboardValidationMessages;
    }
}
export class DashboardNotFoundError extends __BaseException {
    constructor(opts) {
        super({
            name: "DashboardNotFoundError",
            $fault: "client",
            ...opts,
        });
        this.name = "DashboardNotFoundError";
        this.$fault = "client";
        Object.setPrototypeOf(this, DashboardNotFoundError.prototype);
    }
}
export class ResourceNotFound extends __BaseException {
    constructor(opts) {
        super({
            name: "ResourceNotFound",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFound";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFound.prototype);
    }
}
export class InternalServiceFault extends __BaseException {
    constructor(opts) {
        super({
            name: "InternalServiceFault",
            $fault: "server",
            ...opts,
        });
        this.name = "InternalServiceFault";
        this.$fault = "server";
        Object.setPrototypeOf(this, InternalServiceFault.prototype);
        this.Message = opts.Message;
    }
}
export class InvalidParameterCombinationException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidParameterCombinationException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidParameterCombinationException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidParameterCombinationException.prototype);
    }
}
export class InvalidParameterValueException extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidParameterValueException",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidParameterValueException";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidParameterValueException.prototype);
    }
}
export class MissingRequiredParameterException extends __BaseException {
    constructor(opts) {
        super({
            name: "MissingRequiredParameterException",
            $fault: "client",
            ...opts,
        });
        this.name = "MissingRequiredParameterException";
        this.$fault = "client";
        Object.setPrototypeOf(this, MissingRequiredParameterException.prototype);
    }
}
export class ResourceNotFoundException extends __BaseException {
    constructor(opts) {
        super({
            name: "ResourceNotFoundException",
            $fault: "client",
            ...opts,
        });
        this.name = "ResourceNotFoundException";
        this.$fault = "client";
        Object.setPrototypeOf(this, ResourceNotFoundException.prototype);
        this.ResourceType = opts.ResourceType;
        this.ResourceId = opts.ResourceId;
        this.Message = opts.Message;
    }
}
export var ScanBy;
(function (ScanBy) {
    ScanBy["TIMESTAMP_ASCENDING"] = "TimestampAscending";
    ScanBy["TIMESTAMP_DESCENDING"] = "TimestampDescending";
})(ScanBy || (ScanBy = {}));
export class InvalidNextToken extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidNextToken",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidNextToken";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidNextToken.prototype);
    }
}
export var EvaluationState;
(function (EvaluationState) {
    EvaluationState["PARTIAL_DATA"] = "PARTIAL_DATA";
})(EvaluationState || (EvaluationState = {}));
export var Statistic;
(function (Statistic) {
    Statistic["Average"] = "Average";
    Statistic["Maximum"] = "Maximum";
    Statistic["Minimum"] = "Minimum";
    Statistic["SampleCount"] = "SampleCount";
    Statistic["Sum"] = "Sum";
})(Statistic || (Statistic = {}));
export class LimitExceededException extends __BaseException {
    constructor(opts) {
        super({
            name: "LimitExceededException",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededException";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededException.prototype);
        this.Message = opts.Message;
    }
}
export var StatusCode;
(function (StatusCode) {
    StatusCode["COMPLETE"] = "Complete";
    StatusCode["FORBIDDEN"] = "Forbidden";
    StatusCode["INTERNAL_ERROR"] = "InternalError";
    StatusCode["PARTIAL_DATA"] = "PartialData";
})(StatusCode || (StatusCode = {}));
export var MetricStreamOutputFormat;
(function (MetricStreamOutputFormat) {
    MetricStreamOutputFormat["JSON"] = "json";
    MetricStreamOutputFormat["OPEN_TELEMETRY_0_7"] = "opentelemetry0.7";
})(MetricStreamOutputFormat || (MetricStreamOutputFormat = {}));
export var RecentlyActive;
(function (RecentlyActive) {
    RecentlyActive["PT3H"] = "PT3H";
})(RecentlyActive || (RecentlyActive = {}));
export class LimitExceededFault extends __BaseException {
    constructor(opts) {
        super({
            name: "LimitExceededFault",
            $fault: "client",
            ...opts,
        });
        this.name = "LimitExceededFault";
        this.$fault = "client";
        Object.setPrototypeOf(this, LimitExceededFault.prototype);
    }
}
export class InvalidFormatFault extends __BaseException {
    constructor(opts) {
        super({
            name: "InvalidFormatFault",
            $fault: "client",
            ...opts,
        });
        this.name = "InvalidFormatFault";
        this.$fault = "client";
        Object.setPrototypeOf(this, InvalidFormatFault.prototype);
    }
}
export const AlarmHistoryItemFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const RangeFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const AnomalyDetectorConfigurationFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DimensionFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricStatFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricDataQueryFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricMathAnomalyDetectorFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const SingleMetricAnomalyDetectorFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const AnomalyDetectorFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PartialFailureFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const CompositeAlarmFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DashboardEntryFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DashboardValidationMessageFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DatapointFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteAlarmsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteAnomalyDetectorInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteAnomalyDetectorOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteDashboardsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteDashboardsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteMetricStreamInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DeleteMetricStreamOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmHistoryInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmHistoryOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricAlarmFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmsForMetricInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAlarmsForMetricOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAnomalyDetectorsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeAnomalyDetectorsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const InsightRuleFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DescribeInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DimensionFilterFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DisableAlarmActionsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DisableInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const DisableInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const EnableAlarmActionsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const EnableInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const EnableInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetDashboardInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetDashboardOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetInsightRuleReportInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const InsightRuleContributorDatapointFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const InsightRuleContributorFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const InsightRuleMetricDatapointFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetInsightRuleReportOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const LabelOptionsFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricDataInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MessageDataFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricDataResultFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricDataOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricStatisticsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricStatisticsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricStreamInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricStreamFilterFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricStreamStatisticsMetricFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricStreamStatisticsConfigurationFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricStreamOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricWidgetImageInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const GetMetricWidgetImageOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListDashboardsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListDashboardsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListManagedInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ManagedRuleStateFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ManagedRuleDescriptionFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListManagedInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListMetricsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListMetricsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListMetricStreamsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricStreamEntryFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListMetricStreamsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListTagsForResourceInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ListTagsForResourceOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutAnomalyDetectorInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutAnomalyDetectorOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutCompositeAlarmInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutDashboardInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutDashboardOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutInsightRuleInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutInsightRuleOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const ManagedRuleFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutManagedInsightRulesInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutManagedInsightRulesOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutMetricAlarmInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StatisticSetFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const MetricDatumFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutMetricDataInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutMetricStreamInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const PutMetricStreamOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const SetAlarmStateInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StartMetricStreamsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StartMetricStreamsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StopMetricStreamsInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const StopMetricStreamsOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagResourceInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const TagResourceOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const UntagResourceInputFilterSensitiveLog = (obj) => ({
    ...obj,
});
export const UntagResourceOutputFilterSensitiveLog = (obj) => ({
    ...obj,
});
