import { CloudWatchClient } from "../CloudWatchClient";
import { GetMetricDataCommand, } from "../commands/GetMetricDataCommand";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new GetMetricDataCommand(input), ...args);
};
export async function* paginateGetMetricData(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.NextToken = token;
        input["MaxDatapoints"] = config.pageSize;
        if (config.client instanceof CloudWatchClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected CloudWatch | CloudWatchClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextToken;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
