import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { CloudWatchClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../CloudWatchClient";
import { ListManagedInsightRulesInput, ListManagedInsightRulesOutput } from "../models/models_0";
/**
 * The input for {@link ListManagedInsightRulesCommand}.
 */
export interface ListManagedInsightRulesCommandInput extends ListManagedInsightRulesInput {
}
/**
 * The output of {@link ListManagedInsightRulesCommand}.
 */
export interface ListManagedInsightRulesCommandOutput extends ListManagedInsightRulesOutput, __MetadataBearer {
}
/**
 * <p>
 * 			Returns a list
 * 			that contains the number
 * 			of managed Contributor Insights rules
 * 			in your account.
 *
 * 		</p>
 * @example
 * Use a bare-bones client and the command you need to make an API call.
 * ```javascript
 * import { CloudWatchClient, ListManagedInsightRulesCommand } from "@aws-sdk/client-cloudwatch"; // ES Modules import
 * // const { CloudWatchClient, ListManagedInsightRulesCommand } = require("@aws-sdk/client-cloudwatch"); // CommonJS import
 * const client = new CloudWatchClient(config);
 * const command = new ListManagedInsightRulesCommand(input);
 * const response = await client.send(command);
 * ```
 *
 * @see {@link ListManagedInsightRulesCommandInput} for command's `input` shape.
 * @see {@link ListManagedInsightRulesCommandOutput} for command's `response` shape.
 * @see {@link CloudWatchClientResolvedConfig | config} for CloudWatchClient's `config` shape.
 *
 */
export declare class ListManagedInsightRulesCommand extends $Command<ListManagedInsightRulesCommandInput, ListManagedInsightRulesCommandOutput, CloudWatchClientResolvedConfig> {
    readonly input: ListManagedInsightRulesCommandInput;
    static getEndpointParameterInstructions(): EndpointParameterInstructions;
    constructor(input: ListManagedInsightRulesCommandInput);
    /**
     * @internal
     */
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: CloudWatchClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListManagedInsightRulesCommandInput, ListManagedInsightRulesCommandOutput>;
    private serialize;
    private deserialize;
}
