import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  DeleteMetricStreamInput,
  DeleteMetricStreamOutput,
} from "../models/models_0";
export interface DeleteMetricStreamCommandInput
  extends DeleteMetricStreamInput {}
export interface DeleteMetricStreamCommandOutput
  extends DeleteMetricStreamOutput,
    __MetadataBearer {}
export declare class DeleteMetricStreamCommand extends $Command<
  DeleteMetricStreamCommandInput,
  DeleteMetricStreamCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: DeleteMetricStreamCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteMetricStreamCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<DeleteMetricStreamCommandInput, DeleteMetricStreamCommandOutput>;
  private serialize;
  private deserialize;
}
