import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  DescribeAnomalyDetectorsInput,
  DescribeAnomalyDetectorsOutput,
} from "../models/models_0";
export interface DescribeAnomalyDetectorsCommandInput
  extends DescribeAnomalyDetectorsInput {}
export interface DescribeAnomalyDetectorsCommandOutput
  extends DescribeAnomalyDetectorsOutput,
    __MetadataBearer {}
export declare class DescribeAnomalyDetectorsCommand extends $Command<
  DescribeAnomalyDetectorsCommandInput,
  DescribeAnomalyDetectorsCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: DescribeAnomalyDetectorsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeAnomalyDetectorsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeAnomalyDetectorsCommandInput,
    DescribeAnomalyDetectorsCommandOutput
  >;
  private serialize;
  private deserialize;
}
