import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  DescribeInsightRulesInput,
  DescribeInsightRulesOutput,
} from "../models/models_0";
export interface DescribeInsightRulesCommandInput
  extends DescribeInsightRulesInput {}
export interface DescribeInsightRulesCommandOutput
  extends DescribeInsightRulesOutput,
    __MetadataBearer {}
export declare class DescribeInsightRulesCommand extends $Command<
  DescribeInsightRulesCommandInput,
  DescribeInsightRulesCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: DescribeInsightRulesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DescribeInsightRulesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DescribeInsightRulesCommandInput,
    DescribeInsightRulesCommandOutput
  >;
  private serialize;
  private deserialize;
}
