import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  EnableInsightRulesInput,
  EnableInsightRulesOutput,
} from "../models/models_0";
export interface EnableInsightRulesCommandInput
  extends EnableInsightRulesInput {}
export interface EnableInsightRulesCommandOutput
  extends EnableInsightRulesOutput,
    __MetadataBearer {}
export declare class EnableInsightRulesCommand extends $Command<
  EnableInsightRulesCommandInput,
  EnableInsightRulesCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: EnableInsightRulesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: EnableInsightRulesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<EnableInsightRulesCommandInput, EnableInsightRulesCommandOutput>;
  private serialize;
  private deserialize;
}
