import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  GetMetricStatisticsInput,
  GetMetricStatisticsOutput,
} from "../models/models_0";
export interface GetMetricStatisticsCommandInput
  extends GetMetricStatisticsInput {}
export interface GetMetricStatisticsCommandOutput
  extends GetMetricStatisticsOutput,
    __MetadataBearer {}
export declare class GetMetricStatisticsCommand extends $Command<
  GetMetricStatisticsCommandInput,
  GetMetricStatisticsCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: GetMetricStatisticsCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GetMetricStatisticsCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GetMetricStatisticsCommandInput, GetMetricStatisticsCommandOutput>;
  private serialize;
  private deserialize;
}
