import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  ListManagedInsightRulesInput,
  ListManagedInsightRulesOutput,
} from "../models/models_0";
export interface ListManagedInsightRulesCommandInput
  extends ListManagedInsightRulesInput {}
export interface ListManagedInsightRulesCommandOutput
  extends ListManagedInsightRulesOutput,
    __MetadataBearer {}
export declare class ListManagedInsightRulesCommand extends $Command<
  ListManagedInsightRulesCommandInput,
  ListManagedInsightRulesCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: ListManagedInsightRulesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListManagedInsightRulesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    ListManagedInsightRulesCommandInput,
    ListManagedInsightRulesCommandOutput
  >;
  private serialize;
  private deserialize;
}
