import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  CloudWatchClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../CloudWatchClient";
import {
  PutManagedInsightRulesInput,
  PutManagedInsightRulesOutput,
} from "../models/models_0";
export interface PutManagedInsightRulesCommandInput
  extends PutManagedInsightRulesInput {}
export interface PutManagedInsightRulesCommandOutput
  extends PutManagedInsightRulesOutput,
    __MetadataBearer {}
export declare class PutManagedInsightRulesCommand extends $Command<
  PutManagedInsightRulesCommandInput,
  PutManagedInsightRulesCommandOutput,
  CloudWatchClientResolvedConfig
> {
  readonly input: PutManagedInsightRulesCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: PutManagedInsightRulesCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: CloudWatchClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    PutManagedInsightRulesCommandInput,
    PutManagedInsightRulesCommandOutput
  >;
  private serialize;
  private deserialize;
}
