import {
  HttpRequest as __HttpRequest,
  HttpResponse as __HttpResponse,
} from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import {
  DeleteAlarmsCommandInput,
  DeleteAlarmsCommandOutput,
} from "../commands/DeleteAlarmsCommand";
import {
  DeleteAnomalyDetectorCommandInput,
  DeleteAnomalyDetectorCommandOutput,
} from "../commands/DeleteAnomalyDetectorCommand";
import {
  DeleteDashboardsCommandInput,
  DeleteDashboardsCommandOutput,
} from "../commands/DeleteDashboardsCommand";
import {
  DeleteInsightRulesCommandInput,
  DeleteInsightRulesCommandOutput,
} from "../commands/DeleteInsightRulesCommand";
import {
  DeleteMetricStreamCommandInput,
  DeleteMetricStreamCommandOutput,
} from "../commands/DeleteMetricStreamCommand";
import {
  DescribeAlarmHistoryCommandInput,
  DescribeAlarmHistoryCommandOutput,
} from "../commands/DescribeAlarmHistoryCommand";
import {
  DescribeAlarmsCommandInput,
  DescribeAlarmsCommandOutput,
} from "../commands/DescribeAlarmsCommand";
import {
  DescribeAlarmsForMetricCommandInput,
  DescribeAlarmsForMetricCommandOutput,
} from "../commands/DescribeAlarmsForMetricCommand";
import {
  DescribeAnomalyDetectorsCommandInput,
  DescribeAnomalyDetectorsCommandOutput,
} from "../commands/DescribeAnomalyDetectorsCommand";
import {
  DescribeInsightRulesCommandInput,
  DescribeInsightRulesCommandOutput,
} from "../commands/DescribeInsightRulesCommand";
import {
  DisableAlarmActionsCommandInput,
  DisableAlarmActionsCommandOutput,
} from "../commands/DisableAlarmActionsCommand";
import {
  DisableInsightRulesCommandInput,
  DisableInsightRulesCommandOutput,
} from "../commands/DisableInsightRulesCommand";
import {
  EnableAlarmActionsCommandInput,
  EnableAlarmActionsCommandOutput,
} from "../commands/EnableAlarmActionsCommand";
import {
  EnableInsightRulesCommandInput,
  EnableInsightRulesCommandOutput,
} from "../commands/EnableInsightRulesCommand";
import {
  GetDashboardCommandInput,
  GetDashboardCommandOutput,
} from "../commands/GetDashboardCommand";
import {
  GetInsightRuleReportCommandInput,
  GetInsightRuleReportCommandOutput,
} from "../commands/GetInsightRuleReportCommand";
import {
  GetMetricDataCommandInput,
  GetMetricDataCommandOutput,
} from "../commands/GetMetricDataCommand";
import {
  GetMetricStatisticsCommandInput,
  GetMetricStatisticsCommandOutput,
} from "../commands/GetMetricStatisticsCommand";
import {
  GetMetricStreamCommandInput,
  GetMetricStreamCommandOutput,
} from "../commands/GetMetricStreamCommand";
import {
  GetMetricWidgetImageCommandInput,
  GetMetricWidgetImageCommandOutput,
} from "../commands/GetMetricWidgetImageCommand";
import {
  ListDashboardsCommandInput,
  ListDashboardsCommandOutput,
} from "../commands/ListDashboardsCommand";
import {
  ListManagedInsightRulesCommandInput,
  ListManagedInsightRulesCommandOutput,
} from "../commands/ListManagedInsightRulesCommand";
import {
  ListMetricsCommandInput,
  ListMetricsCommandOutput,
} from "../commands/ListMetricsCommand";
import {
  ListMetricStreamsCommandInput,
  ListMetricStreamsCommandOutput,
} from "../commands/ListMetricStreamsCommand";
import {
  ListTagsForResourceCommandInput,
  ListTagsForResourceCommandOutput,
} from "../commands/ListTagsForResourceCommand";
import {
  PutAnomalyDetectorCommandInput,
  PutAnomalyDetectorCommandOutput,
} from "../commands/PutAnomalyDetectorCommand";
import {
  PutCompositeAlarmCommandInput,
  PutCompositeAlarmCommandOutput,
} from "../commands/PutCompositeAlarmCommand";
import {
  PutDashboardCommandInput,
  PutDashboardCommandOutput,
} from "../commands/PutDashboardCommand";
import {
  PutInsightRuleCommandInput,
  PutInsightRuleCommandOutput,
} from "../commands/PutInsightRuleCommand";
import {
  PutManagedInsightRulesCommandInput,
  PutManagedInsightRulesCommandOutput,
} from "../commands/PutManagedInsightRulesCommand";
import {
  PutMetricAlarmCommandInput,
  PutMetricAlarmCommandOutput,
} from "../commands/PutMetricAlarmCommand";
import {
  PutMetricDataCommandInput,
  PutMetricDataCommandOutput,
} from "../commands/PutMetricDataCommand";
import {
  PutMetricStreamCommandInput,
  PutMetricStreamCommandOutput,
} from "../commands/PutMetricStreamCommand";
import {
  SetAlarmStateCommandInput,
  SetAlarmStateCommandOutput,
} from "../commands/SetAlarmStateCommand";
import {
  StartMetricStreamsCommandInput,
  StartMetricStreamsCommandOutput,
} from "../commands/StartMetricStreamsCommand";
import {
  StopMetricStreamsCommandInput,
  StopMetricStreamsCommandOutput,
} from "../commands/StopMetricStreamsCommand";
import {
  TagResourceCommandInput,
  TagResourceCommandOutput,
} from "../commands/TagResourceCommand";
import {
  UntagResourceCommandInput,
  UntagResourceCommandOutput,
} from "../commands/UntagResourceCommand";
export declare const serializeAws_queryDeleteAlarmsCommand: (
  input: DeleteAlarmsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteAnomalyDetectorCommand: (
  input: DeleteAnomalyDetectorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteDashboardsCommand: (
  input: DeleteDashboardsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteInsightRulesCommand: (
  input: DeleteInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDeleteMetricStreamCommand: (
  input: DeleteMetricStreamCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeAlarmHistoryCommand: (
  input: DescribeAlarmHistoryCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeAlarmsCommand: (
  input: DescribeAlarmsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeAlarmsForMetricCommand: (
  input: DescribeAlarmsForMetricCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeAnomalyDetectorsCommand: (
  input: DescribeAnomalyDetectorsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDescribeInsightRulesCommand: (
  input: DescribeInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDisableAlarmActionsCommand: (
  input: DisableAlarmActionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryDisableInsightRulesCommand: (
  input: DisableInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryEnableAlarmActionsCommand: (
  input: EnableAlarmActionsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryEnableInsightRulesCommand: (
  input: EnableInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetDashboardCommand: (
  input: GetDashboardCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetInsightRuleReportCommand: (
  input: GetInsightRuleReportCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetMetricDataCommand: (
  input: GetMetricDataCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetMetricStatisticsCommand: (
  input: GetMetricStatisticsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetMetricStreamCommand: (
  input: GetMetricStreamCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryGetMetricWidgetImageCommand: (
  input: GetMetricWidgetImageCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListDashboardsCommand: (
  input: ListDashboardsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListManagedInsightRulesCommand: (
  input: ListManagedInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListMetricsCommand: (
  input: ListMetricsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListMetricStreamsCommand: (
  input: ListMetricStreamsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryListTagsForResourceCommand: (
  input: ListTagsForResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutAnomalyDetectorCommand: (
  input: PutAnomalyDetectorCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutCompositeAlarmCommand: (
  input: PutCompositeAlarmCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutDashboardCommand: (
  input: PutDashboardCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutInsightRuleCommand: (
  input: PutInsightRuleCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutManagedInsightRulesCommand: (
  input: PutManagedInsightRulesCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutMetricAlarmCommand: (
  input: PutMetricAlarmCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutMetricDataCommand: (
  input: PutMetricDataCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryPutMetricStreamCommand: (
  input: PutMetricStreamCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_querySetAlarmStateCommand: (
  input: SetAlarmStateCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryStartMetricStreamsCommand: (
  input: StartMetricStreamsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryStopMetricStreamsCommand: (
  input: StopMetricStreamsCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryTagResourceCommand: (
  input: TagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const serializeAws_queryUntagResourceCommand: (
  input: UntagResourceCommandInput,
  context: __SerdeContext
) => Promise<__HttpRequest>;
export declare const deserializeAws_queryDeleteAlarmsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteAlarmsCommandOutput>;
export declare const deserializeAws_queryDeleteAnomalyDetectorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteAnomalyDetectorCommandOutput>;
export declare const deserializeAws_queryDeleteDashboardsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteDashboardsCommandOutput>;
export declare const deserializeAws_queryDeleteInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteInsightRulesCommandOutput>;
export declare const deserializeAws_queryDeleteMetricStreamCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DeleteMetricStreamCommandOutput>;
export declare const deserializeAws_queryDescribeAlarmHistoryCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAlarmHistoryCommandOutput>;
export declare const deserializeAws_queryDescribeAlarmsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAlarmsCommandOutput>;
export declare const deserializeAws_queryDescribeAlarmsForMetricCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAlarmsForMetricCommandOutput>;
export declare const deserializeAws_queryDescribeAnomalyDetectorsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeAnomalyDetectorsCommandOutput>;
export declare const deserializeAws_queryDescribeInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DescribeInsightRulesCommandOutput>;
export declare const deserializeAws_queryDisableAlarmActionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DisableAlarmActionsCommandOutput>;
export declare const deserializeAws_queryDisableInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<DisableInsightRulesCommandOutput>;
export declare const deserializeAws_queryEnableAlarmActionsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<EnableAlarmActionsCommandOutput>;
export declare const deserializeAws_queryEnableInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<EnableInsightRulesCommandOutput>;
export declare const deserializeAws_queryGetDashboardCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetDashboardCommandOutput>;
export declare const deserializeAws_queryGetInsightRuleReportCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetInsightRuleReportCommandOutput>;
export declare const deserializeAws_queryGetMetricDataCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMetricDataCommandOutput>;
export declare const deserializeAws_queryGetMetricStatisticsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMetricStatisticsCommandOutput>;
export declare const deserializeAws_queryGetMetricStreamCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMetricStreamCommandOutput>;
export declare const deserializeAws_queryGetMetricWidgetImageCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<GetMetricWidgetImageCommandOutput>;
export declare const deserializeAws_queryListDashboardsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListDashboardsCommandOutput>;
export declare const deserializeAws_queryListManagedInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListManagedInsightRulesCommandOutput>;
export declare const deserializeAws_queryListMetricsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListMetricsCommandOutput>;
export declare const deserializeAws_queryListMetricStreamsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListMetricStreamsCommandOutput>;
export declare const deserializeAws_queryListTagsForResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<ListTagsForResourceCommandOutput>;
export declare const deserializeAws_queryPutAnomalyDetectorCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutAnomalyDetectorCommandOutput>;
export declare const deserializeAws_queryPutCompositeAlarmCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutCompositeAlarmCommandOutput>;
export declare const deserializeAws_queryPutDashboardCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutDashboardCommandOutput>;
export declare const deserializeAws_queryPutInsightRuleCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutInsightRuleCommandOutput>;
export declare const deserializeAws_queryPutManagedInsightRulesCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutManagedInsightRulesCommandOutput>;
export declare const deserializeAws_queryPutMetricAlarmCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutMetricAlarmCommandOutput>;
export declare const deserializeAws_queryPutMetricDataCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutMetricDataCommandOutput>;
export declare const deserializeAws_queryPutMetricStreamCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<PutMetricStreamCommandOutput>;
export declare const deserializeAws_querySetAlarmStateCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<SetAlarmStateCommandOutput>;
export declare const deserializeAws_queryStartMetricStreamsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StartMetricStreamsCommandOutput>;
export declare const deserializeAws_queryStopMetricStreamsCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<StopMetricStreamsCommandOutput>;
export declare const deserializeAws_queryTagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<TagResourceCommandOutput>;
export declare const deserializeAws_queryUntagResourceCommand: (
  output: __HttpResponse,
  context: __SerdeContext
) => Promise<UntagResourceCommandOutput>;
