import { ListKeyPoliciesCommand, } from "../commands/ListKeyPoliciesCommand";
import { KMSClient } from "../KMSClient";
const makePagedClientRequest = async (client, input, ...args) => {
    return await client.send(new ListKeyPoliciesCommand(input), ...args);
};
export async function* paginateListKeyPolicies(config, input, ...additionalArguments) {
    let token = config.startingToken || undefined;
    let hasNext = true;
    let page;
    while (hasNext) {
        input.Marker = token;
        input["Limit"] = config.pageSize;
        if (config.client instanceof KMSClient) {
            page = await makePagedClientRequest(config.client, input, ...additionalArguments);
        }
        else {
            throw new Error("Invalid client, expected KMS | KMSClient");
        }
        yield page;
        const prevToken = token;
        token = page.NextMarker;
        hasNext = !!(token && (!config.stopOnSameToken || token !== prevToken));
    }
    return undefined;
}
