import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import { DecryptRequest, DecryptResponse } from "../models/models_0";
export interface DecryptCommandInput extends DecryptRequest {}
export interface DecryptCommandOutput
  extends DecryptResponse,
    __MetadataBearer {}
export declare class DecryptCommand extends $Command<
  DecryptCommandInput,
  DecryptCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: DecryptCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DecryptCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<DecryptCommandInput, DecryptCommandOutput>;
  private serialize;
  private deserialize;
}
