import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import {
  DeleteCustomKeyStoreRequest,
  DeleteCustomKeyStoreResponse,
} from "../models/models_0";
export interface DeleteCustomKeyStoreCommandInput
  extends DeleteCustomKeyStoreRequest {}
export interface DeleteCustomKeyStoreCommandOutput
  extends DeleteCustomKeyStoreResponse,
    __MetadataBearer {}
export declare class DeleteCustomKeyStoreCommand extends $Command<
  DeleteCustomKeyStoreCommandInput,
  DeleteCustomKeyStoreCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: DeleteCustomKeyStoreCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DeleteCustomKeyStoreCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DeleteCustomKeyStoreCommandInput,
    DeleteCustomKeyStoreCommandOutput
  >;
  private serialize;
  private deserialize;
}
