import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import {
  DisconnectCustomKeyStoreRequest,
  DisconnectCustomKeyStoreResponse,
} from "../models/models_0";
export interface DisconnectCustomKeyStoreCommandInput
  extends DisconnectCustomKeyStoreRequest {}
export interface DisconnectCustomKeyStoreCommandOutput
  extends DisconnectCustomKeyStoreResponse,
    __MetadataBearer {}
export declare class DisconnectCustomKeyStoreCommand extends $Command<
  DisconnectCustomKeyStoreCommandInput,
  DisconnectCustomKeyStoreCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: DisconnectCustomKeyStoreCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: DisconnectCustomKeyStoreCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    DisconnectCustomKeyStoreCommandInput,
    DisconnectCustomKeyStoreCommandOutput
  >;
  private serialize;
  private deserialize;
}
