import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import {
  GenerateDataKeyWithoutPlaintextRequest,
  GenerateDataKeyWithoutPlaintextResponse,
} from "../models/models_0";
export interface GenerateDataKeyWithoutPlaintextCommandInput
  extends GenerateDataKeyWithoutPlaintextRequest {}
export interface GenerateDataKeyWithoutPlaintextCommandOutput
  extends GenerateDataKeyWithoutPlaintextResponse,
    __MetadataBearer {}
export declare class GenerateDataKeyWithoutPlaintextCommand extends $Command<
  GenerateDataKeyWithoutPlaintextCommandInput,
  GenerateDataKeyWithoutPlaintextCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: GenerateDataKeyWithoutPlaintextCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GenerateDataKeyWithoutPlaintextCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    GenerateDataKeyWithoutPlaintextCommandInput,
    GenerateDataKeyWithoutPlaintextCommandOutput
  >;
  private serialize;
  private deserialize;
}
