import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import { GenerateMacRequest, GenerateMacResponse } from "../models/models_0";
export interface GenerateMacCommandInput extends GenerateMacRequest {}
export interface GenerateMacCommandOutput
  extends GenerateMacResponse,
    __MetadataBearer {}
export declare class GenerateMacCommand extends $Command<
  GenerateMacCommandInput,
  GenerateMacCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: GenerateMacCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: GenerateMacCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<GenerateMacCommandInput, GenerateMacCommandOutput>;
  private serialize;
  private deserialize;
}
