import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import { ListKeysRequest, ListKeysResponse } from "../models/models_0";
export interface ListKeysCommandInput extends ListKeysRequest {}
export interface ListKeysCommandOutput
  extends ListKeysResponse,
    __MetadataBearer {}
export declare class ListKeysCommand extends $Command<
  ListKeysCommandInput,
  ListKeysCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: ListKeysCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: ListKeysCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<ListKeysCommandInput, ListKeysCommandOutput>;
  private serialize;
  private deserialize;
}
