import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import { SignRequest, SignResponse } from "../models/models_0";
export interface SignCommandInput extends SignRequest {}
export interface SignCommandOutput extends SignResponse, __MetadataBearer {}
export declare class SignCommand extends $Command<
  SignCommandInput,
  SignCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: SignCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: SignCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<SignCommandInput, SignCommandOutput>;
  private serialize;
  private deserialize;
}
