import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import {
  UpdateCustomKeyStoreRequest,
  UpdateCustomKeyStoreResponse,
} from "../models/models_0";
export interface UpdateCustomKeyStoreCommandInput
  extends UpdateCustomKeyStoreRequest {}
export interface UpdateCustomKeyStoreCommandOutput
  extends UpdateCustomKeyStoreResponse,
    __MetadataBearer {}
export declare class UpdateCustomKeyStoreCommand extends $Command<
  UpdateCustomKeyStoreCommandInput,
  UpdateCustomKeyStoreCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: UpdateCustomKeyStoreCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdateCustomKeyStoreCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<
    UpdateCustomKeyStoreCommandInput,
    UpdateCustomKeyStoreCommandOutput
  >;
  private serialize;
  private deserialize;
}
