import { EndpointParameterInstructions } from "@aws-sdk/middleware-endpoint";
import { Command as $Command } from "@aws-sdk/smithy-client";
import {
  Handler,
  HttpHandlerOptions as __HttpHandlerOptions,
  MetadataBearer as __MetadataBearer,
  MiddlewareStack,
} from "@aws-sdk/types";
import {
  KMSClientResolvedConfig,
  ServiceInputTypes,
  ServiceOutputTypes,
} from "../KMSClient";
import { UpdatePrimaryRegionRequest } from "../models/models_0";
export interface UpdatePrimaryRegionCommandInput
  extends UpdatePrimaryRegionRequest {}
export interface UpdatePrimaryRegionCommandOutput extends __MetadataBearer {}
export declare class UpdatePrimaryRegionCommand extends $Command<
  UpdatePrimaryRegionCommandInput,
  UpdatePrimaryRegionCommandOutput,
  KMSClientResolvedConfig
> {
  readonly input: UpdatePrimaryRegionCommandInput;
  static getEndpointParameterInstructions(): EndpointParameterInstructions;
  constructor(input: UpdatePrimaryRegionCommandInput);
  resolveMiddleware(
    clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>,
    configuration: KMSClientResolvedConfig,
    options?: __HttpHandlerOptions
  ): Handler<UpdatePrimaryRegionCommandInput, UpdatePrimaryRegionCommandOutput>;
  private serialize;
  private deserialize;
}
