import { ExceptionOptionType as __ExceptionOptionType } from "@aws-sdk/smithy-client";
import { KMSServiceException as __BaseException } from "./KMSServiceException";
export declare enum AlgorithmSpec {
  RSAES_OAEP_SHA_1 = "RSAES_OAEP_SHA_1",
  RSAES_OAEP_SHA_256 = "RSAES_OAEP_SHA_256",
  RSAES_PKCS1_V1_5 = "RSAES_PKCS1_V1_5",
}
export interface AliasListEntry {
  AliasName?: string;
  AliasArn?: string;
  TargetKeyId?: string;
  CreationDate?: Date;
  LastUpdatedDate?: Date;
}
export declare class AlreadyExistsException extends __BaseException {
  readonly name: "AlreadyExistsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<AlreadyExistsException, __BaseException>
  );
}
export interface CancelKeyDeletionRequest {
  KeyId: string | undefined;
}
export interface CancelKeyDeletionResponse {
  KeyId?: string;
}
export declare class DependencyTimeoutException extends __BaseException {
  readonly name: "DependencyTimeoutException";
  readonly $fault: "server";
  constructor(
    opts: __ExceptionOptionType<DependencyTimeoutException, __BaseException>
  );
}
export declare class InvalidArnException extends __BaseException {
  readonly name: "InvalidArnException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidArnException, __BaseException>
  );
}
export declare class KMSInternalException extends __BaseException {
  readonly name: "KMSInternalException";
  readonly $fault: "server";
  constructor(
    opts: __ExceptionOptionType<KMSInternalException, __BaseException>
  );
}
export declare class KMSInvalidStateException extends __BaseException {
  readonly name: "KMSInvalidStateException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSInvalidStateException, __BaseException>
  );
}
export declare class NotFoundException extends __BaseException {
  readonly name: "NotFoundException";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<NotFoundException, __BaseException>);
}
export declare class CloudHsmClusterInUseException extends __BaseException {
  readonly name: "CloudHsmClusterInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CloudHsmClusterInUseException, __BaseException>
  );
}
export declare class CloudHsmClusterInvalidConfigurationException extends __BaseException {
  readonly name: "CloudHsmClusterInvalidConfigurationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CloudHsmClusterInvalidConfigurationException,
      __BaseException
    >
  );
}
export declare class CloudHsmClusterNotActiveException extends __BaseException {
  readonly name: "CloudHsmClusterNotActiveException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CloudHsmClusterNotActiveException,
      __BaseException
    >
  );
}
export declare class CloudHsmClusterNotFoundException extends __BaseException {
  readonly name: "CloudHsmClusterNotFoundException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CloudHsmClusterNotFoundException,
      __BaseException
    >
  );
}
export declare class CloudHsmClusterNotRelatedException extends __BaseException {
  readonly name: "CloudHsmClusterNotRelatedException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CloudHsmClusterNotRelatedException,
      __BaseException
    >
  );
}
export interface ConnectCustomKeyStoreRequest {
  CustomKeyStoreId: string | undefined;
}
export interface ConnectCustomKeyStoreResponse {}
export declare class CustomKeyStoreInvalidStateException extends __BaseException {
  readonly name: "CustomKeyStoreInvalidStateException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CustomKeyStoreInvalidStateException,
      __BaseException
    >
  );
}
export declare class CustomKeyStoreNotFoundException extends __BaseException {
  readonly name: "CustomKeyStoreNotFoundException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CustomKeyStoreNotFoundException,
      __BaseException
    >
  );
}
export declare enum ConnectionErrorCodeType {
  CLUSTER_NOT_FOUND = "CLUSTER_NOT_FOUND",
  INSUFFICIENT_CLOUDHSM_HSMS = "INSUFFICIENT_CLOUDHSM_HSMS",
  INSUFFICIENT_FREE_ADDRESSES_IN_SUBNET = "INSUFFICIENT_FREE_ADDRESSES_IN_SUBNET",
  INTERNAL_ERROR = "INTERNAL_ERROR",
  INVALID_CREDENTIALS = "INVALID_CREDENTIALS",
  NETWORK_ERRORS = "NETWORK_ERRORS",
  SUBNET_NOT_FOUND = "SUBNET_NOT_FOUND",
  USER_LOCKED_OUT = "USER_LOCKED_OUT",
  USER_LOGGED_IN = "USER_LOGGED_IN",
  USER_NOT_FOUND = "USER_NOT_FOUND",
  XKS_PROXY_ACCESS_DENIED = "XKS_PROXY_ACCESS_DENIED",
  XKS_PROXY_INVALID_CONFIGURATION = "XKS_PROXY_INVALID_CONFIGURATION",
  XKS_PROXY_INVALID_RESPONSE = "XKS_PROXY_INVALID_RESPONSE",
  XKS_PROXY_INVALID_TLS_CONFIGURATION = "XKS_PROXY_INVALID_TLS_CONFIGURATION",
  XKS_PROXY_NOT_REACHABLE = "XKS_PROXY_NOT_REACHABLE",
  XKS_PROXY_TIMED_OUT = "XKS_PROXY_TIMED_OUT",
  XKS_VPC_ENDPOINT_SERVICE_INVALID_CONFIGURATION = "XKS_VPC_ENDPOINT_SERVICE_INVALID_CONFIGURATION",
  XKS_VPC_ENDPOINT_SERVICE_NOT_FOUND = "XKS_VPC_ENDPOINT_SERVICE_NOT_FOUND",
}
export declare enum ConnectionStateType {
  CONNECTED = "CONNECTED",
  CONNECTING = "CONNECTING",
  DISCONNECTED = "DISCONNECTED",
  DISCONNECTING = "DISCONNECTING",
  FAILED = "FAILED",
}
export interface CreateAliasRequest {
  AliasName: string | undefined;
  TargetKeyId: string | undefined;
}
export declare class InvalidAliasNameException extends __BaseException {
  readonly name: "InvalidAliasNameException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidAliasNameException, __BaseException>
  );
}
export declare class LimitExceededException extends __BaseException {
  readonly name: "LimitExceededException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<LimitExceededException, __BaseException>
  );
}
export declare enum CustomKeyStoreType {
  AWS_CLOUDHSM = "AWS_CLOUDHSM",
  EXTERNAL_KEY_STORE = "EXTERNAL_KEY_STORE",
}
export interface XksProxyAuthenticationCredentialType {
  AccessKeyId: string | undefined;
  RawSecretAccessKey: string | undefined;
}
export declare enum XksProxyConnectivityType {
  PUBLIC_ENDPOINT = "PUBLIC_ENDPOINT",
  VPC_ENDPOINT_SERVICE = "VPC_ENDPOINT_SERVICE",
}
export interface CreateCustomKeyStoreRequest {
  CustomKeyStoreName: string | undefined;
  CloudHsmClusterId?: string;
  TrustAnchorCertificate?: string;
  KeyStorePassword?: string;
  CustomKeyStoreType?: CustomKeyStoreType | string;
  XksProxyUriEndpoint?: string;
  XksProxyUriPath?: string;
  XksProxyVpcEndpointServiceName?: string;
  XksProxyAuthenticationCredential?: XksProxyAuthenticationCredentialType;
  XksProxyConnectivity?: XksProxyConnectivityType | string;
}
export interface CreateCustomKeyStoreResponse {
  CustomKeyStoreId?: string;
}
export declare class CustomKeyStoreNameInUseException extends __BaseException {
  readonly name: "CustomKeyStoreNameInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      CustomKeyStoreNameInUseException,
      __BaseException
    >
  );
}
export declare class IncorrectTrustAnchorException extends __BaseException {
  readonly name: "IncorrectTrustAnchorException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<IncorrectTrustAnchorException, __BaseException>
  );
}
export declare class XksProxyIncorrectAuthenticationCredentialException extends __BaseException {
  readonly name: "XksProxyIncorrectAuthenticationCredentialException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyIncorrectAuthenticationCredentialException,
      __BaseException
    >
  );
}
export declare class XksProxyInvalidConfigurationException extends __BaseException {
  readonly name: "XksProxyInvalidConfigurationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyInvalidConfigurationException,
      __BaseException
    >
  );
}
export declare class XksProxyInvalidResponseException extends __BaseException {
  readonly name: "XksProxyInvalidResponseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyInvalidResponseException,
      __BaseException
    >
  );
}
export declare class XksProxyUriEndpointInUseException extends __BaseException {
  readonly name: "XksProxyUriEndpointInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyUriEndpointInUseException,
      __BaseException
    >
  );
}
export declare class XksProxyUriInUseException extends __BaseException {
  readonly name: "XksProxyUriInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<XksProxyUriInUseException, __BaseException>
  );
}
export declare class XksProxyUriUnreachableException extends __BaseException {
  readonly name: "XksProxyUriUnreachableException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyUriUnreachableException,
      __BaseException
    >
  );
}
export declare class XksProxyVpcEndpointServiceInUseException extends __BaseException {
  readonly name: "XksProxyVpcEndpointServiceInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyVpcEndpointServiceInUseException,
      __BaseException
    >
  );
}
export declare class XksProxyVpcEndpointServiceInvalidConfigurationException extends __BaseException {
  readonly name: "XksProxyVpcEndpointServiceInvalidConfigurationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyVpcEndpointServiceInvalidConfigurationException,
      __BaseException
    >
  );
}
export declare class XksProxyVpcEndpointServiceNotFoundException extends __BaseException {
  readonly name: "XksProxyVpcEndpointServiceNotFoundException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksProxyVpcEndpointServiceNotFoundException,
      __BaseException
    >
  );
}
export interface GrantConstraints {
  EncryptionContextSubset?: Record<string, string>;
  EncryptionContextEquals?: Record<string, string>;
}
export declare enum GrantOperation {
  CreateGrant = "CreateGrant",
  Decrypt = "Decrypt",
  DescribeKey = "DescribeKey",
  Encrypt = "Encrypt",
  GenerateDataKey = "GenerateDataKey",
  GenerateDataKeyPair = "GenerateDataKeyPair",
  GenerateDataKeyPairWithoutPlaintext = "GenerateDataKeyPairWithoutPlaintext",
  GenerateDataKeyWithoutPlaintext = "GenerateDataKeyWithoutPlaintext",
  GenerateMac = "GenerateMac",
  GetPublicKey = "GetPublicKey",
  ReEncryptFrom = "ReEncryptFrom",
  ReEncryptTo = "ReEncryptTo",
  RetireGrant = "RetireGrant",
  Sign = "Sign",
  Verify = "Verify",
  VerifyMac = "VerifyMac",
}
export interface CreateGrantRequest {
  KeyId: string | undefined;
  GranteePrincipal: string | undefined;
  RetiringPrincipal?: string;
  Operations: (GrantOperation | string)[] | undefined;
  Constraints?: GrantConstraints;
  GrantTokens?: string[];
  Name?: string;
}
export interface CreateGrantResponse {
  GrantToken?: string;
  GrantId?: string;
}
export declare class DisabledException extends __BaseException {
  readonly name: "DisabledException";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<DisabledException, __BaseException>);
}
export declare class InvalidGrantTokenException extends __BaseException {
  readonly name: "InvalidGrantTokenException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidGrantTokenException, __BaseException>
  );
}
export declare enum CustomerMasterKeySpec {
  ECC_NIST_P256 = "ECC_NIST_P256",
  ECC_NIST_P384 = "ECC_NIST_P384",
  ECC_NIST_P521 = "ECC_NIST_P521",
  ECC_SECG_P256K1 = "ECC_SECG_P256K1",
  HMAC_224 = "HMAC_224",
  HMAC_256 = "HMAC_256",
  HMAC_384 = "HMAC_384",
  HMAC_512 = "HMAC_512",
  RSA_2048 = "RSA_2048",
  RSA_3072 = "RSA_3072",
  RSA_4096 = "RSA_4096",
  SM2 = "SM2",
  SYMMETRIC_DEFAULT = "SYMMETRIC_DEFAULT",
}
export declare enum KeySpec {
  ECC_NIST_P256 = "ECC_NIST_P256",
  ECC_NIST_P384 = "ECC_NIST_P384",
  ECC_NIST_P521 = "ECC_NIST_P521",
  ECC_SECG_P256K1 = "ECC_SECG_P256K1",
  HMAC_224 = "HMAC_224",
  HMAC_256 = "HMAC_256",
  HMAC_384 = "HMAC_384",
  HMAC_512 = "HMAC_512",
  RSA_2048 = "RSA_2048",
  RSA_3072 = "RSA_3072",
  RSA_4096 = "RSA_4096",
  SM2 = "SM2",
  SYMMETRIC_DEFAULT = "SYMMETRIC_DEFAULT",
}
export declare enum KeyUsageType {
  ENCRYPT_DECRYPT = "ENCRYPT_DECRYPT",
  GENERATE_VERIFY_MAC = "GENERATE_VERIFY_MAC",
  SIGN_VERIFY = "SIGN_VERIFY",
}
export declare enum OriginType {
  AWS_CLOUDHSM = "AWS_CLOUDHSM",
  AWS_KMS = "AWS_KMS",
  EXTERNAL = "EXTERNAL",
  EXTERNAL_KEY_STORE = "EXTERNAL_KEY_STORE",
}
export interface Tag {
  TagKey: string | undefined;
  TagValue: string | undefined;
}
export interface CreateKeyRequest {
  Policy?: string;
  Description?: string;
  KeyUsage?: KeyUsageType | string;
  CustomerMasterKeySpec?: CustomerMasterKeySpec | string;
  KeySpec?: KeySpec | string;
  Origin?: OriginType | string;
  CustomKeyStoreId?: string;
  BypassPolicyLockoutSafetyCheck?: boolean;
  Tags?: Tag[];
  MultiRegion?: boolean;
  XksKeyId?: string;
}
export declare enum EncryptionAlgorithmSpec {
  RSAES_OAEP_SHA_1 = "RSAES_OAEP_SHA_1",
  RSAES_OAEP_SHA_256 = "RSAES_OAEP_SHA_256",
  SM2PKE = "SM2PKE",
  SYMMETRIC_DEFAULT = "SYMMETRIC_DEFAULT",
}
export declare enum ExpirationModelType {
  KEY_MATERIAL_DOES_NOT_EXPIRE = "KEY_MATERIAL_DOES_NOT_EXPIRE",
  KEY_MATERIAL_EXPIRES = "KEY_MATERIAL_EXPIRES",
}
export declare enum KeyManagerType {
  AWS = "AWS",
  CUSTOMER = "CUSTOMER",
}
export declare enum KeyState {
  Creating = "Creating",
  Disabled = "Disabled",
  Enabled = "Enabled",
  PendingDeletion = "PendingDeletion",
  PendingImport = "PendingImport",
  PendingReplicaDeletion = "PendingReplicaDeletion",
  Unavailable = "Unavailable",
  Updating = "Updating",
}
export declare enum MacAlgorithmSpec {
  HMAC_SHA_224 = "HMAC_SHA_224",
  HMAC_SHA_256 = "HMAC_SHA_256",
  HMAC_SHA_384 = "HMAC_SHA_384",
  HMAC_SHA_512 = "HMAC_SHA_512",
}
export declare enum MultiRegionKeyType {
  PRIMARY = "PRIMARY",
  REPLICA = "REPLICA",
}
export interface MultiRegionKey {
  Arn?: string;
  Region?: string;
}
export interface MultiRegionConfiguration {
  MultiRegionKeyType?: MultiRegionKeyType | string;
  PrimaryKey?: MultiRegionKey;
  ReplicaKeys?: MultiRegionKey[];
}
export declare enum SigningAlgorithmSpec {
  ECDSA_SHA_256 = "ECDSA_SHA_256",
  ECDSA_SHA_384 = "ECDSA_SHA_384",
  ECDSA_SHA_512 = "ECDSA_SHA_512",
  RSASSA_PKCS1_V1_5_SHA_256 = "RSASSA_PKCS1_V1_5_SHA_256",
  RSASSA_PKCS1_V1_5_SHA_384 = "RSASSA_PKCS1_V1_5_SHA_384",
  RSASSA_PKCS1_V1_5_SHA_512 = "RSASSA_PKCS1_V1_5_SHA_512",
  RSASSA_PSS_SHA_256 = "RSASSA_PSS_SHA_256",
  RSASSA_PSS_SHA_384 = "RSASSA_PSS_SHA_384",
  RSASSA_PSS_SHA_512 = "RSASSA_PSS_SHA_512",
  SM2DSA = "SM2DSA",
}
export interface XksKeyConfigurationType {
  Id?: string;
}
export interface KeyMetadata {
  AWSAccountId?: string;
  KeyId: string | undefined;
  Arn?: string;
  CreationDate?: Date;
  Enabled?: boolean;
  Description?: string;
  KeyUsage?: KeyUsageType | string;
  KeyState?: KeyState | string;
  DeletionDate?: Date;
  ValidTo?: Date;
  Origin?: OriginType | string;
  CustomKeyStoreId?: string;
  CloudHsmClusterId?: string;
  ExpirationModel?: ExpirationModelType | string;
  KeyManager?: KeyManagerType | string;
  CustomerMasterKeySpec?: CustomerMasterKeySpec | string;
  KeySpec?: KeySpec | string;
  EncryptionAlgorithms?: (EncryptionAlgorithmSpec | string)[];
  SigningAlgorithms?: (SigningAlgorithmSpec | string)[];
  MultiRegion?: boolean;
  MultiRegionConfiguration?: MultiRegionConfiguration;
  PendingDeletionWindowInDays?: number;
  MacAlgorithms?: (MacAlgorithmSpec | string)[];
  XksKeyConfiguration?: XksKeyConfigurationType;
}
export interface CreateKeyResponse {
  KeyMetadata?: KeyMetadata;
}
export declare class MalformedPolicyDocumentException extends __BaseException {
  readonly name: "MalformedPolicyDocumentException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      MalformedPolicyDocumentException,
      __BaseException
    >
  );
}
export declare class TagException extends __BaseException {
  readonly name: "TagException";
  readonly $fault: "client";
  constructor(opts: __ExceptionOptionType<TagException, __BaseException>);
}
export declare class UnsupportedOperationException extends __BaseException {
  readonly name: "UnsupportedOperationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<UnsupportedOperationException, __BaseException>
  );
}
export declare class XksKeyAlreadyInUseException extends __BaseException {
  readonly name: "XksKeyAlreadyInUseException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<XksKeyAlreadyInUseException, __BaseException>
  );
}
export declare class XksKeyInvalidConfigurationException extends __BaseException {
  readonly name: "XksKeyInvalidConfigurationException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<
      XksKeyInvalidConfigurationException,
      __BaseException
    >
  );
}
export declare class XksKeyNotFoundException extends __BaseException {
  readonly name: "XksKeyNotFoundException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<XksKeyNotFoundException, __BaseException>
  );
}
export declare class CustomKeyStoreHasCMKsException extends __BaseException {
  readonly name: "CustomKeyStoreHasCMKsException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<CustomKeyStoreHasCMKsException, __BaseException>
  );
}
export interface XksProxyConfigurationType {
  Connectivity?: XksProxyConnectivityType | string;
  AccessKeyId?: string;
  UriEndpoint?: string;
  UriPath?: string;
  VpcEndpointServiceName?: string;
}
export interface CustomKeyStoresListEntry {
  CustomKeyStoreId?: string;
  CustomKeyStoreName?: string;
  CloudHsmClusterId?: string;
  TrustAnchorCertificate?: string;
  ConnectionState?: ConnectionStateType | string;
  ConnectionErrorCode?: ConnectionErrorCodeType | string;
  CreationDate?: Date;
  CustomKeyStoreType?: CustomKeyStoreType | string;
  XksProxyConfiguration?: XksProxyConfigurationType;
}
export declare enum DataKeyPairSpec {
  ECC_NIST_P256 = "ECC_NIST_P256",
  ECC_NIST_P384 = "ECC_NIST_P384",
  ECC_NIST_P521 = "ECC_NIST_P521",
  ECC_SECG_P256K1 = "ECC_SECG_P256K1",
  RSA_2048 = "RSA_2048",
  RSA_3072 = "RSA_3072",
  RSA_4096 = "RSA_4096",
  SM2 = "SM2",
}
export declare enum DataKeySpec {
  AES_128 = "AES_128",
  AES_256 = "AES_256",
}
export interface DecryptRequest {
  CiphertextBlob: Uint8Array | undefined;
  EncryptionContext?: Record<string, string>;
  GrantTokens?: string[];
  KeyId?: string;
  EncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
}
export interface DecryptResponse {
  KeyId?: string;
  Plaintext?: Uint8Array;
  EncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
}
export declare class IncorrectKeyException extends __BaseException {
  readonly name: "IncorrectKeyException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<IncorrectKeyException, __BaseException>
  );
}
export declare class InvalidCiphertextException extends __BaseException {
  readonly name: "InvalidCiphertextException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidCiphertextException, __BaseException>
  );
}
export declare class InvalidKeyUsageException extends __BaseException {
  readonly name: "InvalidKeyUsageException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidKeyUsageException, __BaseException>
  );
}
export declare class KeyUnavailableException extends __BaseException {
  readonly name: "KeyUnavailableException";
  readonly $fault: "server";
  constructor(
    opts: __ExceptionOptionType<KeyUnavailableException, __BaseException>
  );
}
export interface DeleteAliasRequest {
  AliasName: string | undefined;
}
export interface DeleteCustomKeyStoreRequest {
  CustomKeyStoreId: string | undefined;
}
export interface DeleteCustomKeyStoreResponse {}
export interface DeleteImportedKeyMaterialRequest {
  KeyId: string | undefined;
}
export interface DescribeCustomKeyStoresRequest {
  CustomKeyStoreId?: string;
  CustomKeyStoreName?: string;
  Limit?: number;
  Marker?: string;
}
export interface DescribeCustomKeyStoresResponse {
  CustomKeyStores?: CustomKeyStoresListEntry[];
  NextMarker?: string;
  Truncated?: boolean;
}
export declare class InvalidMarkerException extends __BaseException {
  readonly name: "InvalidMarkerException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidMarkerException, __BaseException>
  );
}
export interface DescribeKeyRequest {
  KeyId: string | undefined;
  GrantTokens?: string[];
}
export interface DescribeKeyResponse {
  KeyMetadata?: KeyMetadata;
}
export interface DisableKeyRequest {
  KeyId: string | undefined;
}
export interface DisableKeyRotationRequest {
  KeyId: string | undefined;
}
export interface DisconnectCustomKeyStoreRequest {
  CustomKeyStoreId: string | undefined;
}
export interface DisconnectCustomKeyStoreResponse {}
export interface EnableKeyRequest {
  KeyId: string | undefined;
}
export interface EnableKeyRotationRequest {
  KeyId: string | undefined;
}
export interface EncryptRequest {
  KeyId: string | undefined;
  Plaintext: Uint8Array | undefined;
  EncryptionContext?: Record<string, string>;
  GrantTokens?: string[];
  EncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
}
export interface EncryptResponse {
  CiphertextBlob?: Uint8Array;
  KeyId?: string;
  EncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
}
export declare class ExpiredImportTokenException extends __BaseException {
  readonly name: "ExpiredImportTokenException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<ExpiredImportTokenException, __BaseException>
  );
}
export interface GenerateDataKeyRequest {
  KeyId: string | undefined;
  EncryptionContext?: Record<string, string>;
  NumberOfBytes?: number;
  KeySpec?: DataKeySpec | string;
  GrantTokens?: string[];
}
export interface GenerateDataKeyResponse {
  CiphertextBlob?: Uint8Array;
  Plaintext?: Uint8Array;
  KeyId?: string;
}
export interface GenerateDataKeyPairRequest {
  EncryptionContext?: Record<string, string>;
  KeyId: string | undefined;
  KeyPairSpec: DataKeyPairSpec | string | undefined;
  GrantTokens?: string[];
}
export interface GenerateDataKeyPairResponse {
  PrivateKeyCiphertextBlob?: Uint8Array;
  PrivateKeyPlaintext?: Uint8Array;
  PublicKey?: Uint8Array;
  KeyId?: string;
  KeyPairSpec?: DataKeyPairSpec | string;
}
export interface GenerateDataKeyPairWithoutPlaintextRequest {
  EncryptionContext?: Record<string, string>;
  KeyId: string | undefined;
  KeyPairSpec: DataKeyPairSpec | string | undefined;
  GrantTokens?: string[];
}
export interface GenerateDataKeyPairWithoutPlaintextResponse {
  PrivateKeyCiphertextBlob?: Uint8Array;
  PublicKey?: Uint8Array;
  KeyId?: string;
  KeyPairSpec?: DataKeyPairSpec | string;
}
export interface GenerateDataKeyWithoutPlaintextRequest {
  KeyId: string | undefined;
  EncryptionContext?: Record<string, string>;
  KeySpec?: DataKeySpec | string;
  NumberOfBytes?: number;
  GrantTokens?: string[];
}
export interface GenerateDataKeyWithoutPlaintextResponse {
  CiphertextBlob?: Uint8Array;
  KeyId?: string;
}
export interface GenerateMacRequest {
  Message: Uint8Array | undefined;
  KeyId: string | undefined;
  MacAlgorithm: MacAlgorithmSpec | string | undefined;
  GrantTokens?: string[];
}
export interface GenerateMacResponse {
  Mac?: Uint8Array;
  MacAlgorithm?: MacAlgorithmSpec | string;
  KeyId?: string;
}
export interface GenerateRandomRequest {
  NumberOfBytes?: number;
  CustomKeyStoreId?: string;
}
export interface GenerateRandomResponse {
  Plaintext?: Uint8Array;
}
export interface GetKeyPolicyRequest {
  KeyId: string | undefined;
  PolicyName: string | undefined;
}
export interface GetKeyPolicyResponse {
  Policy?: string;
}
export interface GetKeyRotationStatusRequest {
  KeyId: string | undefined;
}
export interface GetKeyRotationStatusResponse {
  KeyRotationEnabled?: boolean;
}
export declare enum WrappingKeySpec {
  RSA_2048 = "RSA_2048",
}
export interface GetParametersForImportRequest {
  KeyId: string | undefined;
  WrappingAlgorithm: AlgorithmSpec | string | undefined;
  WrappingKeySpec: WrappingKeySpec | string | undefined;
}
export interface GetParametersForImportResponse {
  KeyId?: string;
  ImportToken?: Uint8Array;
  PublicKey?: Uint8Array;
  ParametersValidTo?: Date;
}
export interface GetPublicKeyRequest {
  KeyId: string | undefined;
  GrantTokens?: string[];
}
export interface GetPublicKeyResponse {
  KeyId?: string;
  PublicKey?: Uint8Array;
  CustomerMasterKeySpec?: CustomerMasterKeySpec | string;
  KeySpec?: KeySpec | string;
  KeyUsage?: KeyUsageType | string;
  EncryptionAlgorithms?: (EncryptionAlgorithmSpec | string)[];
  SigningAlgorithms?: (SigningAlgorithmSpec | string)[];
}
export interface GrantListEntry {
  KeyId?: string;
  GrantId?: string;
  Name?: string;
  CreationDate?: Date;
  GranteePrincipal?: string;
  RetiringPrincipal?: string;
  IssuingAccount?: string;
  Operations?: (GrantOperation | string)[];
  Constraints?: GrantConstraints;
}
export interface ImportKeyMaterialRequest {
  KeyId: string | undefined;
  ImportToken: Uint8Array | undefined;
  EncryptedKeyMaterial: Uint8Array | undefined;
  ValidTo?: Date;
  ExpirationModel?: ExpirationModelType | string;
}
export interface ImportKeyMaterialResponse {}
export declare class IncorrectKeyMaterialException extends __BaseException {
  readonly name: "IncorrectKeyMaterialException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<IncorrectKeyMaterialException, __BaseException>
  );
}
export declare class InvalidImportTokenException extends __BaseException {
  readonly name: "InvalidImportTokenException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidImportTokenException, __BaseException>
  );
}
export declare class InvalidGrantIdException extends __BaseException {
  readonly name: "InvalidGrantIdException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<InvalidGrantIdException, __BaseException>
  );
}
export interface KeyListEntry {
  KeyId?: string;
  KeyArn?: string;
}
export declare class KMSInvalidMacException extends __BaseException {
  readonly name: "KMSInvalidMacException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSInvalidMacException, __BaseException>
  );
}
export declare class KMSInvalidSignatureException extends __BaseException {
  readonly name: "KMSInvalidSignatureException";
  readonly $fault: "client";
  constructor(
    opts: __ExceptionOptionType<KMSInvalidSignatureException, __BaseException>
  );
}
export interface ListAliasesRequest {
  KeyId?: string;
  Limit?: number;
  Marker?: string;
}
export interface ListAliasesResponse {
  Aliases?: AliasListEntry[];
  NextMarker?: string;
  Truncated?: boolean;
}
export interface ListGrantsRequest {
  Limit?: number;
  Marker?: string;
  KeyId: string | undefined;
  GrantId?: string;
  GranteePrincipal?: string;
}
export interface ListGrantsResponse {
  Grants?: GrantListEntry[];
  NextMarker?: string;
  Truncated?: boolean;
}
export interface ListKeyPoliciesRequest {
  KeyId: string | undefined;
  Limit?: number;
  Marker?: string;
}
export interface ListKeyPoliciesResponse {
  PolicyNames?: string[];
  NextMarker?: string;
  Truncated?: boolean;
}
export interface ListKeysRequest {
  Limit?: number;
  Marker?: string;
}
export interface ListKeysResponse {
  Keys?: KeyListEntry[];
  NextMarker?: string;
  Truncated?: boolean;
}
export interface ListResourceTagsRequest {
  KeyId: string | undefined;
  Limit?: number;
  Marker?: string;
}
export interface ListResourceTagsResponse {
  Tags?: Tag[];
  NextMarker?: string;
  Truncated?: boolean;
}
export interface ListRetirableGrantsRequest {
  Limit?: number;
  Marker?: string;
  RetiringPrincipal: string | undefined;
}
export declare enum MessageType {
  DIGEST = "DIGEST",
  RAW = "RAW",
}
export interface PutKeyPolicyRequest {
  KeyId: string | undefined;
  PolicyName: string | undefined;
  Policy: string | undefined;
  BypassPolicyLockoutSafetyCheck?: boolean;
}
export interface ReEncryptRequest {
  CiphertextBlob: Uint8Array | undefined;
  SourceEncryptionContext?: Record<string, string>;
  SourceKeyId?: string;
  DestinationKeyId: string | undefined;
  DestinationEncryptionContext?: Record<string, string>;
  SourceEncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
  DestinationEncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
  GrantTokens?: string[];
}
export interface ReEncryptResponse {
  CiphertextBlob?: Uint8Array;
  SourceKeyId?: string;
  KeyId?: string;
  SourceEncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
  DestinationEncryptionAlgorithm?: EncryptionAlgorithmSpec | string;
}
export interface ReplicateKeyRequest {
  KeyId: string | undefined;
  ReplicaRegion: string | undefined;
  Policy?: string;
  BypassPolicyLockoutSafetyCheck?: boolean;
  Description?: string;
  Tags?: Tag[];
}
export interface ReplicateKeyResponse {
  ReplicaKeyMetadata?: KeyMetadata;
  ReplicaPolicy?: string;
  ReplicaTags?: Tag[];
}
export interface RetireGrantRequest {
  GrantToken?: string;
  KeyId?: string;
  GrantId?: string;
}
export interface RevokeGrantRequest {
  KeyId: string | undefined;
  GrantId: string | undefined;
}
export interface ScheduleKeyDeletionRequest {
  KeyId: string | undefined;
  PendingWindowInDays?: number;
}
export interface ScheduleKeyDeletionResponse {
  KeyId?: string;
  DeletionDate?: Date;
  KeyState?: KeyState | string;
  PendingWindowInDays?: number;
}
export interface SignRequest {
  KeyId: string | undefined;
  Message: Uint8Array | undefined;
  MessageType?: MessageType | string;
  GrantTokens?: string[];
  SigningAlgorithm: SigningAlgorithmSpec | string | undefined;
}
export interface SignResponse {
  KeyId?: string;
  Signature?: Uint8Array;
  SigningAlgorithm?: SigningAlgorithmSpec | string;
}
export interface TagResourceRequest {
  KeyId: string | undefined;
  Tags: Tag[] | undefined;
}
export interface UntagResourceRequest {
  KeyId: string | undefined;
  TagKeys: string[] | undefined;
}
export interface UpdateAliasRequest {
  AliasName: string | undefined;
  TargetKeyId: string | undefined;
}
export interface UpdateCustomKeyStoreRequest {
  CustomKeyStoreId: string | undefined;
  NewCustomKeyStoreName?: string;
  KeyStorePassword?: string;
  CloudHsmClusterId?: string;
  XksProxyUriEndpoint?: string;
  XksProxyUriPath?: string;
  XksProxyVpcEndpointServiceName?: string;
  XksProxyAuthenticationCredential?: XksProxyAuthenticationCredentialType;
  XksProxyConnectivity?: XksProxyConnectivityType | string;
}
export interface UpdateCustomKeyStoreResponse {}
export interface UpdateKeyDescriptionRequest {
  KeyId: string | undefined;
  Description: string | undefined;
}
export interface UpdatePrimaryRegionRequest {
  KeyId: string | undefined;
  PrimaryRegion: string | undefined;
}
export interface VerifyRequest {
  KeyId: string | undefined;
  Message: Uint8Array | undefined;
  MessageType?: MessageType | string;
  Signature: Uint8Array | undefined;
  SigningAlgorithm: SigningAlgorithmSpec | string | undefined;
  GrantTokens?: string[];
}
export interface VerifyResponse {
  KeyId?: string;
  SignatureValid?: boolean;
  SigningAlgorithm?: SigningAlgorithmSpec | string;
}
export interface VerifyMacRequest {
  Message: Uint8Array | undefined;
  KeyId: string | undefined;
  MacAlgorithm: MacAlgorithmSpec | string | undefined;
  Mac: Uint8Array | undefined;
  GrantTokens?: string[];
}
export interface VerifyMacResponse {
  KeyId?: string;
  MacValid?: boolean;
  MacAlgorithm?: MacAlgorithmSpec | string;
}
export declare const AliasListEntryFilterSensitiveLog: (
  obj: AliasListEntry
) => any;
export declare const CancelKeyDeletionRequestFilterSensitiveLog: (
  obj: CancelKeyDeletionRequest
) => any;
export declare const CancelKeyDeletionResponseFilterSensitiveLog: (
  obj: CancelKeyDeletionResponse
) => any;
export declare const ConnectCustomKeyStoreRequestFilterSensitiveLog: (
  obj: ConnectCustomKeyStoreRequest
) => any;
export declare const ConnectCustomKeyStoreResponseFilterSensitiveLog: (
  obj: ConnectCustomKeyStoreResponse
) => any;
export declare const CreateAliasRequestFilterSensitiveLog: (
  obj: CreateAliasRequest
) => any;
export declare const XksProxyAuthenticationCredentialTypeFilterSensitiveLog: (
  obj: XksProxyAuthenticationCredentialType
) => any;
export declare const CreateCustomKeyStoreRequestFilterSensitiveLog: (
  obj: CreateCustomKeyStoreRequest
) => any;
export declare const CreateCustomKeyStoreResponseFilterSensitiveLog: (
  obj: CreateCustomKeyStoreResponse
) => any;
export declare const GrantConstraintsFilterSensitiveLog: (
  obj: GrantConstraints
) => any;
export declare const CreateGrantRequestFilterSensitiveLog: (
  obj: CreateGrantRequest
) => any;
export declare const CreateGrantResponseFilterSensitiveLog: (
  obj: CreateGrantResponse
) => any;
export declare const TagFilterSensitiveLog: (obj: Tag) => any;
export declare const CreateKeyRequestFilterSensitiveLog: (
  obj: CreateKeyRequest
) => any;
export declare const MultiRegionKeyFilterSensitiveLog: (
  obj: MultiRegionKey
) => any;
export declare const MultiRegionConfigurationFilterSensitiveLog: (
  obj: MultiRegionConfiguration
) => any;
export declare const XksKeyConfigurationTypeFilterSensitiveLog: (
  obj: XksKeyConfigurationType
) => any;
export declare const KeyMetadataFilterSensitiveLog: (obj: KeyMetadata) => any;
export declare const CreateKeyResponseFilterSensitiveLog: (
  obj: CreateKeyResponse
) => any;
export declare const XksProxyConfigurationTypeFilterSensitiveLog: (
  obj: XksProxyConfigurationType
) => any;
export declare const CustomKeyStoresListEntryFilterSensitiveLog: (
  obj: CustomKeyStoresListEntry
) => any;
export declare const DecryptRequestFilterSensitiveLog: (
  obj: DecryptRequest
) => any;
export declare const DecryptResponseFilterSensitiveLog: (
  obj: DecryptResponse
) => any;
export declare const DeleteAliasRequestFilterSensitiveLog: (
  obj: DeleteAliasRequest
) => any;
export declare const DeleteCustomKeyStoreRequestFilterSensitiveLog: (
  obj: DeleteCustomKeyStoreRequest
) => any;
export declare const DeleteCustomKeyStoreResponseFilterSensitiveLog: (
  obj: DeleteCustomKeyStoreResponse
) => any;
export declare const DeleteImportedKeyMaterialRequestFilterSensitiveLog: (
  obj: DeleteImportedKeyMaterialRequest
) => any;
export declare const DescribeCustomKeyStoresRequestFilterSensitiveLog: (
  obj: DescribeCustomKeyStoresRequest
) => any;
export declare const DescribeCustomKeyStoresResponseFilterSensitiveLog: (
  obj: DescribeCustomKeyStoresResponse
) => any;
export declare const DescribeKeyRequestFilterSensitiveLog: (
  obj: DescribeKeyRequest
) => any;
export declare const DescribeKeyResponseFilterSensitiveLog: (
  obj: DescribeKeyResponse
) => any;
export declare const DisableKeyRequestFilterSensitiveLog: (
  obj: DisableKeyRequest
) => any;
export declare const DisableKeyRotationRequestFilterSensitiveLog: (
  obj: DisableKeyRotationRequest
) => any;
export declare const DisconnectCustomKeyStoreRequestFilterSensitiveLog: (
  obj: DisconnectCustomKeyStoreRequest
) => any;
export declare const DisconnectCustomKeyStoreResponseFilterSensitiveLog: (
  obj: DisconnectCustomKeyStoreResponse
) => any;
export declare const EnableKeyRequestFilterSensitiveLog: (
  obj: EnableKeyRequest
) => any;
export declare const EnableKeyRotationRequestFilterSensitiveLog: (
  obj: EnableKeyRotationRequest
) => any;
export declare const EncryptRequestFilterSensitiveLog: (
  obj: EncryptRequest
) => any;
export declare const EncryptResponseFilterSensitiveLog: (
  obj: EncryptResponse
) => any;
export declare const GenerateDataKeyRequestFilterSensitiveLog: (
  obj: GenerateDataKeyRequest
) => any;
export declare const GenerateDataKeyResponseFilterSensitiveLog: (
  obj: GenerateDataKeyResponse
) => any;
export declare const GenerateDataKeyPairRequestFilterSensitiveLog: (
  obj: GenerateDataKeyPairRequest
) => any;
export declare const GenerateDataKeyPairResponseFilterSensitiveLog: (
  obj: GenerateDataKeyPairResponse
) => any;
export declare const GenerateDataKeyPairWithoutPlaintextRequestFilterSensitiveLog: (
  obj: GenerateDataKeyPairWithoutPlaintextRequest
) => any;
export declare const GenerateDataKeyPairWithoutPlaintextResponseFilterSensitiveLog: (
  obj: GenerateDataKeyPairWithoutPlaintextResponse
) => any;
export declare const GenerateDataKeyWithoutPlaintextRequestFilterSensitiveLog: (
  obj: GenerateDataKeyWithoutPlaintextRequest
) => any;
export declare const GenerateDataKeyWithoutPlaintextResponseFilterSensitiveLog: (
  obj: GenerateDataKeyWithoutPlaintextResponse
) => any;
export declare const GenerateMacRequestFilterSensitiveLog: (
  obj: GenerateMacRequest
) => any;
export declare const GenerateMacResponseFilterSensitiveLog: (
  obj: GenerateMacResponse
) => any;
export declare const GenerateRandomRequestFilterSensitiveLog: (
  obj: GenerateRandomRequest
) => any;
export declare const GenerateRandomResponseFilterSensitiveLog: (
  obj: GenerateRandomResponse
) => any;
export declare const GetKeyPolicyRequestFilterSensitiveLog: (
  obj: GetKeyPolicyRequest
) => any;
export declare const GetKeyPolicyResponseFilterSensitiveLog: (
  obj: GetKeyPolicyResponse
) => any;
export declare const GetKeyRotationStatusRequestFilterSensitiveLog: (
  obj: GetKeyRotationStatusRequest
) => any;
export declare const GetKeyRotationStatusResponseFilterSensitiveLog: (
  obj: GetKeyRotationStatusResponse
) => any;
export declare const GetParametersForImportRequestFilterSensitiveLog: (
  obj: GetParametersForImportRequest
) => any;
export declare const GetParametersForImportResponseFilterSensitiveLog: (
  obj: GetParametersForImportResponse
) => any;
export declare const GetPublicKeyRequestFilterSensitiveLog: (
  obj: GetPublicKeyRequest
) => any;
export declare const GetPublicKeyResponseFilterSensitiveLog: (
  obj: GetPublicKeyResponse
) => any;
export declare const GrantListEntryFilterSensitiveLog: (
  obj: GrantListEntry
) => any;
export declare const ImportKeyMaterialRequestFilterSensitiveLog: (
  obj: ImportKeyMaterialRequest
) => any;
export declare const ImportKeyMaterialResponseFilterSensitiveLog: (
  obj: ImportKeyMaterialResponse
) => any;
export declare const KeyListEntryFilterSensitiveLog: (obj: KeyListEntry) => any;
export declare const ListAliasesRequestFilterSensitiveLog: (
  obj: ListAliasesRequest
) => any;
export declare const ListAliasesResponseFilterSensitiveLog: (
  obj: ListAliasesResponse
) => any;
export declare const ListGrantsRequestFilterSensitiveLog: (
  obj: ListGrantsRequest
) => any;
export declare const ListGrantsResponseFilterSensitiveLog: (
  obj: ListGrantsResponse
) => any;
export declare const ListKeyPoliciesRequestFilterSensitiveLog: (
  obj: ListKeyPoliciesRequest
) => any;
export declare const ListKeyPoliciesResponseFilterSensitiveLog: (
  obj: ListKeyPoliciesResponse
) => any;
export declare const ListKeysRequestFilterSensitiveLog: (
  obj: ListKeysRequest
) => any;
export declare const ListKeysResponseFilterSensitiveLog: (
  obj: ListKeysResponse
) => any;
export declare const ListResourceTagsRequestFilterSensitiveLog: (
  obj: ListResourceTagsRequest
) => any;
export declare const ListResourceTagsResponseFilterSensitiveLog: (
  obj: ListResourceTagsResponse
) => any;
export declare const ListRetirableGrantsRequestFilterSensitiveLog: (
  obj: ListRetirableGrantsRequest
) => any;
export declare const PutKeyPolicyRequestFilterSensitiveLog: (
  obj: PutKeyPolicyRequest
) => any;
export declare const ReEncryptRequestFilterSensitiveLog: (
  obj: ReEncryptRequest
) => any;
export declare const ReEncryptResponseFilterSensitiveLog: (
  obj: ReEncryptResponse
) => any;
export declare const ReplicateKeyRequestFilterSensitiveLog: (
  obj: ReplicateKeyRequest
) => any;
export declare const ReplicateKeyResponseFilterSensitiveLog: (
  obj: ReplicateKeyResponse
) => any;
export declare const RetireGrantRequestFilterSensitiveLog: (
  obj: RetireGrantRequest
) => any;
export declare const RevokeGrantRequestFilterSensitiveLog: (
  obj: RevokeGrantRequest
) => any;
export declare const ScheduleKeyDeletionRequestFilterSensitiveLog: (
  obj: ScheduleKeyDeletionRequest
) => any;
export declare const ScheduleKeyDeletionResponseFilterSensitiveLog: (
  obj: ScheduleKeyDeletionResponse
) => any;
export declare const SignRequestFilterSensitiveLog: (obj: SignRequest) => any;
export declare const SignResponseFilterSensitiveLog: (obj: SignResponse) => any;
export declare const TagResourceRequestFilterSensitiveLog: (
  obj: TagResourceRequest
) => any;
export declare const UntagResourceRequestFilterSensitiveLog: (
  obj: UntagResourceRequest
) => any;
export declare const UpdateAliasRequestFilterSensitiveLog: (
  obj: UpdateAliasRequest
) => any;
export declare const UpdateCustomKeyStoreRequestFilterSensitiveLog: (
  obj: UpdateCustomKeyStoreRequest
) => any;
export declare const UpdateCustomKeyStoreResponseFilterSensitiveLog: (
  obj: UpdateCustomKeyStoreResponse
) => any;
export declare const UpdateKeyDescriptionRequestFilterSensitiveLog: (
  obj: UpdateKeyDescriptionRequest
) => any;
export declare const UpdatePrimaryRegionRequestFilterSensitiveLog: (
  obj: UpdatePrimaryRegionRequest
) => any;
export declare const VerifyRequestFilterSensitiveLog: (
  obj: VerifyRequest
) => any;
export declare const VerifyResponseFilterSensitiveLog: (
  obj: VerifyResponse
) => any;
export declare const VerifyMacRequestFilterSensitiveLog: (
  obj: VerifyMacRequest
) => any;
export declare const VerifyMacResponseFilterSensitiveLog: (
  obj: VerifyMacResponse
) => any;
