## API Report File for "@azure/arm-keyvault"

> Do not edit this file. It is a report generated by [API Extractor](https://api-extractor.com/).

```ts

import * as coreAuth from '@azure/core-auth';
import * as coreClient from '@azure/core-client';
import { PagedAsyncIterableIterator } from '@azure/core-paging';
import { PollerLike } from '@azure/core-lro';
import { PollOperationState } from '@azure/core-lro';

// @public
export interface AccessPolicyEntry {
    applicationId?: string;
    objectId: string;
    permissions: Permissions_2;
    tenantId: string;
}

// @public
export type AccessPolicyUpdateKind = "add" | "replace" | "remove";

// @public
export type ActionsRequired = string;

// @public
export interface Attributes {
    readonly created?: Date;
    enabled?: boolean;
    expires?: Date;
    notBefore?: Date;
    readonly updated?: Date;
}

// @public
export type CertificatePermissions = string;

// @public
export interface CheckNameAvailabilityResult {
    readonly message?: string;
    readonly nameAvailable?: boolean;
    readonly reason?: Reason;
}

// @public
export interface CloudError {
    error?: CloudErrorBody;
}

// @public
export interface CloudErrorBody {
    code?: string;
    message?: string;
}

// @public
export type CreateMode = "recover" | "default";

// @public (undocumented)
export interface DeletedManagedHsm {
    readonly id?: string;
    readonly name?: string;
    properties?: DeletedManagedHsmProperties;
    readonly type?: string;
}

// @public
export interface DeletedManagedHsmListResult {
    nextLink?: string;
    value?: DeletedManagedHsm[];
}

// @public
export interface DeletedManagedHsmProperties {
    readonly deletionDate?: Date;
    readonly location?: string;
    readonly mhsmId?: string;
    readonly purgeProtectionEnabled?: boolean;
    readonly scheduledPurgeDate?: Date;
    readonly tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface DeletedVault {
    readonly id?: string;
    readonly name?: string;
    properties?: DeletedVaultProperties;
    readonly type?: string;
}

// @public
export interface DeletedVaultListResult {
    nextLink?: string;
    value?: DeletedVault[];
}

// @public
export interface DeletedVaultProperties {
    readonly deletionDate?: Date;
    readonly location?: string;
    readonly purgeProtectionEnabled?: boolean;
    readonly scheduledPurgeDate?: Date;
    readonly tags?: {
        [propertyName: string]: string;
    };
    readonly vaultId?: string;
}

// @public
export type DeletionRecoveryLevel = string;

// @public
export interface DimensionProperties {
    displayName?: string;
    name?: string;
    toBeExportedForShoebox?: boolean;
}

// @public
export interface ErrorModel {
    readonly code?: string;
    readonly innerError?: ErrorModel;
    readonly message?: string;
}

// @public
export type IdentityType = string;

// @public
export interface IPRule {
    value: string;
}

// @public
export type JsonWebKeyCurveName = string;

// @public
export type JsonWebKeyOperation = string;

// @public
export type JsonWebKeyType = string;

// @public
export type Key = Resource & {
    attributes?: KeyAttributes;
    kty?: JsonWebKeyType;
    keyOps?: JsonWebKeyOperation[];
    keySize?: number;
    curveName?: JsonWebKeyCurveName;
    readonly keyUri?: string;
    readonly keyUriWithVersion?: string;
};

// @public
export interface KeyAttributes {
    readonly created?: number;
    enabled?: boolean;
    expires?: number;
    exportable?: boolean;
    notBefore?: number;
    readonly recoveryLevel?: DeletionRecoveryLevel;
    readonly updated?: number;
}

// @public
export interface KeyCreateParameters {
    properties: KeyProperties;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface KeyListResult {
    nextLink?: string;
    value?: Key[];
}

// @public
export type KeyPermissions = string;

// @public
export interface KeyProperties {
    attributes?: KeyAttributes;
    curveName?: JsonWebKeyCurveName;
    // (undocumented)
    keyOps?: JsonWebKeyOperation[];
    keySize?: number;
    readonly keyUri?: string;
    readonly keyUriWithVersion?: string;
    kty?: JsonWebKeyType;
}

// @public
export interface Keys {
    createIfNotExist(resourceGroupName: string, vaultName: string, keyName: string, parameters: KeyCreateParameters, options?: KeysCreateIfNotExistOptionalParams): Promise<KeysCreateIfNotExistResponse>;
    get(resourceGroupName: string, vaultName: string, keyName: string, options?: KeysGetOptionalParams): Promise<KeysGetResponse>;
    getVersion(resourceGroupName: string, vaultName: string, keyName: string, keyVersion: string, options?: KeysGetVersionOptionalParams): Promise<KeysGetVersionResponse>;
    list(resourceGroupName: string, vaultName: string, options?: KeysListOptionalParams): PagedAsyncIterableIterator<Key>;
    listVersions(resourceGroupName: string, vaultName: string, keyName: string, options?: KeysListVersionsOptionalParams): PagedAsyncIterableIterator<Key>;
}

// @public
export interface KeysCreateIfNotExistOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysCreateIfNotExistResponse = Key;

// @public
export interface KeysGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysGetResponse = Key;

// @public
export interface KeysGetVersionOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysGetVersionResponse = Key;

// @public
export interface KeysListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysListNextResponse = KeyListResult;

// @public
export interface KeysListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysListResponse = KeyListResult;

// @public
export interface KeysListVersionsNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysListVersionsNextResponse = KeyListResult;

// @public
export interface KeysListVersionsOptionalParams extends coreClient.OperationOptions {
}

// @public
export type KeysListVersionsResponse = KeyListResult;

// @public (undocumented)
export class KeyVaultManagementClient extends coreClient.ServiceClient {
    // (undocumented)
    $host: string;
    constructor(credentials: coreAuth.TokenCredential, subscriptionId: string, options?: KeyVaultManagementClientOptionalParams);
    // (undocumented)
    apiVersion: string;
    // (undocumented)
    keys: Keys;
    // (undocumented)
    managedHsms: ManagedHsms;
    // (undocumented)
    mhsmPrivateEndpointConnections: MhsmPrivateEndpointConnections;
    // (undocumented)
    mhsmPrivateLinkResources: MhsmPrivateLinkResources;
    // (undocumented)
    operations: Operations;
    // (undocumented)
    privateEndpointConnections: PrivateEndpointConnections;
    // (undocumented)
    privateLinkResources: PrivateLinkResources;
    // (undocumented)
    secrets: Secrets;
    // (undocumented)
    subscriptionId: string;
    // (undocumented)
    vaults: Vaults;
}

// @public
export interface KeyVaultManagementClientOptionalParams extends coreClient.ServiceClientOptions {
    $host?: string;
    apiVersion?: string;
    endpoint?: string;
}

// @public
export enum KnownActionsRequired {
    // (undocumented)
    None = "None"
}

// @public
export enum KnownCertificatePermissions {
    // (undocumented)
    All = "all",
    // (undocumented)
    Backup = "backup",
    // (undocumented)
    Create = "create",
    // (undocumented)
    Delete = "delete",
    // (undocumented)
    Deleteissuers = "deleteissuers",
    // (undocumented)
    Get = "get",
    // (undocumented)
    Getissuers = "getissuers",
    // (undocumented)
    Import = "import",
    // (undocumented)
    List = "list",
    // (undocumented)
    Listissuers = "listissuers",
    // (undocumented)
    Managecontacts = "managecontacts",
    // (undocumented)
    Manageissuers = "manageissuers",
    // (undocumented)
    Purge = "purge",
    // (undocumented)
    Recover = "recover",
    // (undocumented)
    Restore = "restore",
    // (undocumented)
    Setissuers = "setissuers",
    // (undocumented)
    Update = "update"
}

// @public
export enum KnownDeletionRecoveryLevel {
    // (undocumented)
    Purgeable = "Purgeable",
    // (undocumented)
    Recoverable = "Recoverable",
    // (undocumented)
    RecoverableProtectedSubscription = "Recoverable+ProtectedSubscription",
    // (undocumented)
    RecoverablePurgeable = "Recoverable+Purgeable"
}

// @public
export enum KnownIdentityType {
    // (undocumented)
    Application = "Application",
    // (undocumented)
    Key = "Key",
    // (undocumented)
    ManagedIdentity = "ManagedIdentity",
    // (undocumented)
    User = "User"
}

// @public
export enum KnownJsonWebKeyCurveName {
    // (undocumented)
    P256 = "P-256",
    // (undocumented)
    P256K = "P-256K",
    // (undocumented)
    P384 = "P-384",
    // (undocumented)
    P521 = "P-521"
}

// @public
export enum KnownJsonWebKeyOperation {
    // (undocumented)
    Decrypt = "decrypt",
    // (undocumented)
    Encrypt = "encrypt",
    // (undocumented)
    Import = "import",
    // (undocumented)
    Sign = "sign",
    // (undocumented)
    UnwrapKey = "unwrapKey",
    // (undocumented)
    Verify = "verify",
    // (undocumented)
    WrapKey = "wrapKey"
}

// @public
export enum KnownJsonWebKeyType {
    // (undocumented)
    EC = "EC",
    // (undocumented)
    ECHSM = "EC-HSM",
    // (undocumented)
    RSA = "RSA",
    // (undocumented)
    RSAHSM = "RSA-HSM"
}

// @public
export enum KnownKeyPermissions {
    // (undocumented)
    All = "all",
    // (undocumented)
    Backup = "backup",
    // (undocumented)
    Create = "create",
    // (undocumented)
    Decrypt = "decrypt",
    // (undocumented)
    Delete = "delete",
    // (undocumented)
    Encrypt = "encrypt",
    // (undocumented)
    Get = "get",
    // (undocumented)
    Import = "import",
    // (undocumented)
    List = "list",
    // (undocumented)
    Purge = "purge",
    // (undocumented)
    Recover = "recover",
    // (undocumented)
    Restore = "restore",
    // (undocumented)
    Sign = "sign",
    // (undocumented)
    UnwrapKey = "unwrapKey",
    // (undocumented)
    Update = "update",
    // (undocumented)
    Verify = "verify",
    // (undocumented)
    WrapKey = "wrapKey"
}

// @public
export enum KnownManagedHsmSkuFamily {
    // (undocumented)
    B = "B"
}

// @public
export enum KnownNetworkRuleAction {
    // (undocumented)
    Allow = "Allow",
    // (undocumented)
    Deny = "Deny"
}

// @public
export enum KnownNetworkRuleBypassOptions {
    // (undocumented)
    AzureServices = "AzureServices",
    // (undocumented)
    None = "None"
}

// @public
export enum KnownPrivateEndpointConnectionProvisioningState {
    // (undocumented)
    Creating = "Creating",
    // (undocumented)
    Deleting = "Deleting",
    // (undocumented)
    Disconnected = "Disconnected",
    // (undocumented)
    Failed = "Failed",
    // (undocumented)
    Succeeded = "Succeeded",
    // (undocumented)
    Updating = "Updating"
}

// @public
export enum KnownPrivateEndpointServiceConnectionStatus {
    // (undocumented)
    Approved = "Approved",
    // (undocumented)
    Disconnected = "Disconnected",
    // (undocumented)
    Pending = "Pending",
    // (undocumented)
    Rejected = "Rejected"
}

// @public
export enum KnownProvisioningState {
    Activated = "Activated",
    Deleting = "Deleting",
    Failed = "Failed",
    Provisioning = "Provisioning",
    Restoring = "Restoring",
    SecurityDomainRestore = "SecurityDomainRestore",
    Succeeded = "Succeeded",
    Updating = "Updating"
}

// @public
export enum KnownPublicNetworkAccess {
    // (undocumented)
    Disabled = "Disabled",
    // (undocumented)
    Enabled = "Enabled"
}

// @public
export enum KnownSecretPermissions {
    // (undocumented)
    All = "all",
    // (undocumented)
    Backup = "backup",
    // (undocumented)
    Delete = "delete",
    // (undocumented)
    Get = "get",
    // (undocumented)
    List = "list",
    // (undocumented)
    Purge = "purge",
    // (undocumented)
    Recover = "recover",
    // (undocumented)
    Restore = "restore",
    // (undocumented)
    Set = "set"
}

// @public
export enum KnownSkuFamily {
    // (undocumented)
    A = "A"
}

// @public
export enum KnownStoragePermissions {
    // (undocumented)
    All = "all",
    // (undocumented)
    Backup = "backup",
    // (undocumented)
    Delete = "delete",
    // (undocumented)
    Deletesas = "deletesas",
    // (undocumented)
    Get = "get",
    // (undocumented)
    Getsas = "getsas",
    // (undocumented)
    List = "list",
    // (undocumented)
    Listsas = "listsas",
    // (undocumented)
    Purge = "purge",
    // (undocumented)
    Recover = "recover",
    // (undocumented)
    Regeneratekey = "regeneratekey",
    // (undocumented)
    Restore = "restore",
    // (undocumented)
    Set = "set",
    // (undocumented)
    Setsas = "setsas",
    // (undocumented)
    Update = "update"
}

// @public
export enum KnownVaultProvisioningState {
    // (undocumented)
    RegisteringDns = "RegisteringDns",
    // (undocumented)
    Succeeded = "Succeeded"
}

// @public
export interface LogSpecification {
    blobDuration?: string;
    displayName?: string;
    name?: string;
}

// @public
export type ManagedHsm = ManagedHsmResource & {
    properties?: ManagedHsmProperties;
};

// @public
export interface ManagedHsmError {
    readonly error?: ErrorModel;
}

// @public
export interface ManagedHsmListResult {
    nextLink?: string;
    value?: ManagedHsm[];
}

// @public
export interface ManagedHsmProperties {
    createMode?: CreateMode;
    enablePurgeProtection?: boolean;
    enableSoftDelete?: boolean;
    readonly hsmUri?: string;
    initialAdminObjectIds?: string[];
    networkAcls?: MhsmNetworkRuleSet;
    readonly privateEndpointConnections?: MhsmPrivateEndpointConnectionItem[];
    readonly provisioningState?: ProvisioningState;
    publicNetworkAccess?: PublicNetworkAccess;
    readonly scheduledPurgeDate?: Date;
    softDeleteRetentionInDays?: number;
    readonly statusMessage?: string;
    tenantId?: string;
}

// @public
export interface ManagedHsmResource {
    readonly id?: string;
    location?: string;
    readonly name?: string;
    sku?: ManagedHsmSku;
    readonly systemData?: SystemData;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface ManagedHsms {
    beginCreateOrUpdate(resourceGroupName: string, name: string, parameters: ManagedHsm, options?: ManagedHsmsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<ManagedHsmsCreateOrUpdateResponse>, ManagedHsmsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, name: string, parameters: ManagedHsm, options?: ManagedHsmsCreateOrUpdateOptionalParams): Promise<ManagedHsmsCreateOrUpdateResponse>;
    beginDelete(resourceGroupName: string, name: string, options?: ManagedHsmsDeleteOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginDeleteAndWait(resourceGroupName: string, name: string, options?: ManagedHsmsDeleteOptionalParams): Promise<void>;
    beginPurgeDeleted(name: string, location: string, options?: ManagedHsmsPurgeDeletedOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginPurgeDeletedAndWait(name: string, location: string, options?: ManagedHsmsPurgeDeletedOptionalParams): Promise<void>;
    beginUpdate(resourceGroupName: string, name: string, parameters: ManagedHsm, options?: ManagedHsmsUpdateOptionalParams): Promise<PollerLike<PollOperationState<ManagedHsmsUpdateResponse>, ManagedHsmsUpdateResponse>>;
    beginUpdateAndWait(resourceGroupName: string, name: string, parameters: ManagedHsm, options?: ManagedHsmsUpdateOptionalParams): Promise<ManagedHsmsUpdateResponse>;
    get(resourceGroupName: string, name: string, options?: ManagedHsmsGetOptionalParams): Promise<ManagedHsmsGetResponse>;
    getDeleted(name: string, location: string, options?: ManagedHsmsGetDeletedOptionalParams): Promise<ManagedHsmsGetDeletedResponse>;
    listByResourceGroup(resourceGroupName: string, options?: ManagedHsmsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<ManagedHsm>;
    listBySubscription(options?: ManagedHsmsListBySubscriptionOptionalParams): PagedAsyncIterableIterator<ManagedHsm>;
    listDeleted(options?: ManagedHsmsListDeletedOptionalParams): PagedAsyncIterableIterator<DeletedManagedHsm>;
}

// @public
export interface ManagedHsmsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ManagedHsmsCreateOrUpdateResponse = ManagedHsm;

// @public
export interface ManagedHsmsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ManagedHsmsGetDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ManagedHsmsGetDeletedResponse = DeletedManagedHsm;

// @public
export interface ManagedHsmsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ManagedHsmsGetResponse = ManagedHsm;

// @public
export interface ManagedHsmSku {
    family: ManagedHsmSkuFamily;
    name: ManagedHsmSkuName;
}

// @public
export type ManagedHsmSkuFamily = string;

// @public
export type ManagedHsmSkuName = "Standard_B1" | "Custom_B32";

// @public
export interface ManagedHsmsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type ManagedHsmsListByResourceGroupNextResponse = ManagedHsmListResult;

// @public
export interface ManagedHsmsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type ManagedHsmsListByResourceGroupResponse = ManagedHsmListResult;

// @public
export interface ManagedHsmsListBySubscriptionNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type ManagedHsmsListBySubscriptionNextResponse = ManagedHsmListResult;

// @public
export interface ManagedHsmsListBySubscriptionOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type ManagedHsmsListBySubscriptionResponse = ManagedHsmListResult;

// @public
export interface ManagedHsmsListDeletedNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ManagedHsmsListDeletedNextResponse = DeletedManagedHsmListResult;

// @public
export interface ManagedHsmsListDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type ManagedHsmsListDeletedResponse = DeletedManagedHsmListResult;

// @public
export interface ManagedHsmsPurgeDeletedOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface ManagedHsmsUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type ManagedHsmsUpdateResponse = ManagedHsm;

// @public
export interface MetricSpecification {
    aggregationType?: string;
    dimensions?: DimensionProperties[];
    displayDescription?: string;
    displayName?: string;
    fillGapWithZero?: boolean;
    internalMetricName?: string;
    lockAggregationType?: string;
    name?: string;
    supportedAggregationTypes?: string[];
    supportedTimeGrainTypes?: string[];
    unit?: string;
}

// @public
export interface MhsmipRule {
    value: string;
}

// @public
export interface MhsmNetworkRuleSet {
    bypass?: NetworkRuleBypassOptions;
    defaultAction?: NetworkRuleAction;
    ipRules?: MhsmipRule[];
    virtualNetworkRules?: MhsmVirtualNetworkRule[];
}

// @public
export interface MhsmPrivateEndpoint {
    readonly id?: string;
}

// @public
export type MhsmPrivateEndpointConnection = ManagedHsmResource & {
    etag?: string;
    privateEndpoint?: MhsmPrivateEndpoint;
    privateLinkServiceConnectionState?: MhsmPrivateLinkServiceConnectionState;
    provisioningState?: PrivateEndpointConnectionProvisioningState;
};

// @public
export interface MhsmPrivateEndpointConnectionItem {
    privateEndpoint?: MhsmPrivateEndpoint;
    privateLinkServiceConnectionState?: MhsmPrivateLinkServiceConnectionState;
    provisioningState?: PrivateEndpointConnectionProvisioningState;
}

// @public
export interface MhsmPrivateEndpointConnections {
    beginDelete(resourceGroupName: string, name: string, privateEndpointConnectionName: string, options?: MhsmPrivateEndpointConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<MhsmPrivateEndpointConnectionsDeleteResponse>, MhsmPrivateEndpointConnectionsDeleteResponse>>;
    beginDeleteAndWait(resourceGroupName: string, name: string, privateEndpointConnectionName: string, options?: MhsmPrivateEndpointConnectionsDeleteOptionalParams): Promise<MhsmPrivateEndpointConnectionsDeleteResponse>;
    get(resourceGroupName: string, name: string, privateEndpointConnectionName: string, options?: MhsmPrivateEndpointConnectionsGetOptionalParams): Promise<MhsmPrivateEndpointConnectionsGetResponse>;
    listByResource(resourceGroupName: string, name: string, options?: MhsmPrivateEndpointConnectionsListByResourceOptionalParams): PagedAsyncIterableIterator<MhsmPrivateEndpointConnection>;
    put(resourceGroupName: string, name: string, privateEndpointConnectionName: string, properties: MhsmPrivateEndpointConnection, options?: MhsmPrivateEndpointConnectionsPutOptionalParams): Promise<MhsmPrivateEndpointConnectionsPutResponse>;
}

// @public
export interface MhsmPrivateEndpointConnectionsDeleteHeaders {
    location?: string;
    retryAfter?: number;
}

// @public
export interface MhsmPrivateEndpointConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type MhsmPrivateEndpointConnectionsDeleteResponse = MhsmPrivateEndpointConnection;

// @public
export interface MhsmPrivateEndpointConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type MhsmPrivateEndpointConnectionsGetResponse = MhsmPrivateEndpointConnection;

// @public
export interface MhsmPrivateEndpointConnectionsListByResourceNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type MhsmPrivateEndpointConnectionsListByResourceNextResponse = MhsmPrivateEndpointConnectionsListResult;

// @public
export interface MhsmPrivateEndpointConnectionsListByResourceOptionalParams extends coreClient.OperationOptions {
}

// @public
export type MhsmPrivateEndpointConnectionsListByResourceResponse = MhsmPrivateEndpointConnectionsListResult;

// @public
export interface MhsmPrivateEndpointConnectionsListResult {
    nextLink?: string;
    value?: MhsmPrivateEndpointConnection[];
}

// @public
export interface MhsmPrivateEndpointConnectionsPutHeaders {
    azureAsyncOperation?: string;
    retryAfter?: number;
}

// @public
export interface MhsmPrivateEndpointConnectionsPutOptionalParams extends coreClient.OperationOptions {
}

// @public
export type MhsmPrivateEndpointConnectionsPutResponse = MhsmPrivateEndpointConnectionsPutHeaders & MhsmPrivateEndpointConnection;

// @public
export type MhsmPrivateLinkResource = ManagedHsmResource & {
    readonly groupId?: string;
    readonly requiredMembers?: string[];
    requiredZoneNames?: string[];
};

// @public
export interface MhsmPrivateLinkResourceListResult {
    value?: MhsmPrivateLinkResource[];
}

// @public
export interface MhsmPrivateLinkResources {
    listByMhsmResource(resourceGroupName: string, name: string, options?: MhsmPrivateLinkResourcesListByMhsmResourceOptionalParams): Promise<MhsmPrivateLinkResourcesListByMhsmResourceResponse>;
}

// @public
export interface MhsmPrivateLinkResourcesListByMhsmResourceOptionalParams extends coreClient.OperationOptions {
}

// @public
export type MhsmPrivateLinkResourcesListByMhsmResourceResponse = MhsmPrivateLinkResourceListResult;

// @public
export interface MhsmPrivateLinkServiceConnectionState {
    actionsRequired?: ActionsRequired;
    description?: string;
    status?: PrivateEndpointServiceConnectionStatus;
}

// @public
export interface MhsmVirtualNetworkRule {
    id: string;
}

// @public
export type NetworkRuleAction = string;

// @public
export type NetworkRuleBypassOptions = string;

// @public
export interface NetworkRuleSet {
    bypass?: NetworkRuleBypassOptions;
    defaultAction?: NetworkRuleAction;
    ipRules?: IPRule[];
    virtualNetworkRules?: VirtualNetworkRule[];
}

// @public
export interface Operation {
    display?: OperationDisplay;
    isDataAction?: boolean;
    name?: string;
    origin?: string;
    serviceSpecification?: ServiceSpecification;
}

// @public
export interface OperationDisplay {
    description?: string;
    operation?: string;
    provider?: string;
    resource?: string;
}

// @public
export interface OperationListResult {
    nextLink?: string;
    value?: Operation[];
}

// @public
export interface Operations {
    list(options?: OperationsListOptionalParams): PagedAsyncIterableIterator<Operation>;
}

// @public
export interface OperationsListNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListNextResponse = OperationListResult;

// @public
export interface OperationsListOptionalParams extends coreClient.OperationOptions {
}

// @public
export type OperationsListResponse = OperationListResult;

// @public
interface Permissions_2 {
    certificates?: CertificatePermissions[];
    keys?: KeyPermissions[];
    secrets?: SecretPermissions[];
    storage?: StoragePermissions[];
}
export { Permissions_2 as Permissions }

// @public
export interface PrivateEndpoint {
    readonly id?: string;
}

// @public
export type PrivateEndpointConnection = Resource & {
    etag?: string;
    privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    provisioningState?: PrivateEndpointConnectionProvisioningState;
};

// @public
export interface PrivateEndpointConnectionItem {
    etag?: string;
    id?: string;
    privateEndpoint?: PrivateEndpoint;
    privateLinkServiceConnectionState?: PrivateLinkServiceConnectionState;
    provisioningState?: PrivateEndpointConnectionProvisioningState;
}

// @public
export interface PrivateEndpointConnectionListResult {
    nextLink?: string;
    value?: PrivateEndpointConnection[];
}

// @public
export type PrivateEndpointConnectionProvisioningState = string;

// @public
export interface PrivateEndpointConnections {
    beginDelete(resourceGroupName: string, vaultName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsDeleteOptionalParams): Promise<PollerLike<PollOperationState<PrivateEndpointConnectionsDeleteResponse>, PrivateEndpointConnectionsDeleteResponse>>;
    beginDeleteAndWait(resourceGroupName: string, vaultName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsDeleteOptionalParams): Promise<PrivateEndpointConnectionsDeleteResponse>;
    get(resourceGroupName: string, vaultName: string, privateEndpointConnectionName: string, options?: PrivateEndpointConnectionsGetOptionalParams): Promise<PrivateEndpointConnectionsGetResponse>;
    listByResource(resourceGroupName: string, vaultName: string, options?: PrivateEndpointConnectionsListByResourceOptionalParams): PagedAsyncIterableIterator<PrivateEndpointConnection>;
    put(resourceGroupName: string, vaultName: string, privateEndpointConnectionName: string, properties: PrivateEndpointConnection, options?: PrivateEndpointConnectionsPutOptionalParams): Promise<PrivateEndpointConnectionsPutResponse>;
}

// @public
export interface PrivateEndpointConnectionsDeleteHeaders {
    location?: string;
    retryAfter?: number;
}

// @public
export interface PrivateEndpointConnectionsDeleteOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type PrivateEndpointConnectionsDeleteResponse = PrivateEndpointConnection;

// @public
export interface PrivateEndpointConnectionsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsGetResponse = PrivateEndpointConnection;

// @public
export interface PrivateEndpointConnectionsListByResourceNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsListByResourceNextResponse = PrivateEndpointConnectionListResult;

// @public
export interface PrivateEndpointConnectionsListByResourceOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsListByResourceResponse = PrivateEndpointConnectionListResult;

// @public
export interface PrivateEndpointConnectionsPutHeaders {
    azureAsyncOperation?: string;
    retryAfter?: number;
}

// @public
export interface PrivateEndpointConnectionsPutOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateEndpointConnectionsPutResponse = PrivateEndpointConnectionsPutHeaders & PrivateEndpointConnection;

// @public
export type PrivateEndpointServiceConnectionStatus = string;

// @public
export type PrivateLinkResource = Resource & {
    readonly groupId?: string;
    readonly requiredMembers?: string[];
    requiredZoneNames?: string[];
};

// @public
export interface PrivateLinkResourceListResult {
    value?: PrivateLinkResource[];
}

// @public
export interface PrivateLinkResources {
    listByVault(resourceGroupName: string, vaultName: string, options?: PrivateLinkResourcesListByVaultOptionalParams): Promise<PrivateLinkResourcesListByVaultResponse>;
}

// @public
export interface PrivateLinkResourcesListByVaultOptionalParams extends coreClient.OperationOptions {
}

// @public
export type PrivateLinkResourcesListByVaultResponse = PrivateLinkResourceListResult;

// @public
export interface PrivateLinkServiceConnectionState {
    actionsRequired?: ActionsRequired;
    description?: string;
    status?: PrivateEndpointServiceConnectionStatus;
}

// @public
export type ProvisioningState = string;

// @public
export type PublicNetworkAccess = string;

// @public
export type Reason = "AccountNameInvalid" | "AlreadyExists";

// @public
export interface Resource {
    readonly id?: string;
    readonly location?: string;
    readonly name?: string;
    readonly tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface ResourceListResult {
    nextLink?: string;
    value?: Resource[];
}

// @public
export type Secret = Resource & {
    properties: SecretProperties;
};

// @public
export type SecretAttributes = Attributes & {};

// @public
export interface SecretCreateOrUpdateParameters {
    properties: SecretProperties;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface SecretListResult {
    nextLink?: string;
    value?: Secret[];
}

// @public
export interface SecretPatchParameters {
    properties?: SecretPatchProperties;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface SecretPatchProperties {
    attributes?: SecretAttributes;
    contentType?: string;
    value?: string;
}

// @public
export type SecretPermissions = string;

// @public
export interface SecretProperties {
    attributes?: SecretAttributes;
    contentType?: string;
    readonly secretUri?: string;
    readonly secretUriWithVersion?: string;
    value?: string;
}

// @public
export interface Secrets {
    createOrUpdate(resourceGroupName: string, vaultName: string, secretName: string, parameters: SecretCreateOrUpdateParameters, options?: SecretsCreateOrUpdateOptionalParams): Promise<SecretsCreateOrUpdateResponse>;
    get(resourceGroupName: string, vaultName: string, secretName: string, options?: SecretsGetOptionalParams): Promise<SecretsGetResponse>;
    list(resourceGroupName: string, vaultName: string, options?: SecretsListOptionalParams): PagedAsyncIterableIterator<Secret>;
    update(resourceGroupName: string, vaultName: string, secretName: string, parameters: SecretPatchParameters, options?: SecretsUpdateOptionalParams): Promise<SecretsUpdateResponse>;
}

// @public
export interface SecretsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecretsCreateOrUpdateResponse = Secret;

// @public
export interface SecretsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecretsGetResponse = Secret;

// @public
export interface SecretsListNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type SecretsListNextResponse = SecretListResult;

// @public
export interface SecretsListOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type SecretsListResponse = SecretListResult;

// @public
export interface SecretsUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type SecretsUpdateResponse = Secret;

// @public
export interface ServiceSpecification {
    logSpecifications?: LogSpecification[];
    metricSpecifications?: MetricSpecification[];
}

// @public
export interface Sku {
    family: SkuFamily;
    name: SkuName;
}

// @public
export type SkuFamily = string;

// @public
export type SkuName = "standard" | "premium";

// @public
export type StoragePermissions = string;

// @public
export interface SystemData {
    createdAt?: Date;
    createdBy?: string;
    createdByType?: IdentityType;
    lastModifiedAt?: Date;
    lastModifiedBy?: string;
    lastModifiedByType?: IdentityType;
}

// @public
export interface Vault {
    readonly id?: string;
    location?: string;
    readonly name?: string;
    properties: VaultProperties;
    readonly systemData?: SystemData;
    tags?: {
        [propertyName: string]: string;
    };
    readonly type?: string;
}

// @public
export interface VaultAccessPolicyParameters {
    readonly id?: string;
    readonly location?: string;
    readonly name?: string;
    properties: VaultAccessPolicyProperties;
    readonly type?: string;
}

// @public
export interface VaultAccessPolicyProperties {
    accessPolicies: AccessPolicyEntry[];
}

// @public
export interface VaultCheckNameAvailabilityParameters {
    name: string;
    type: "Microsoft.KeyVault/vaults";
}

// @public
export interface VaultCreateOrUpdateParameters {
    location: string;
    properties: VaultProperties;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface VaultListResult {
    nextLink?: string;
    value?: Vault[];
}

// @public
export interface VaultPatchParameters {
    properties?: VaultPatchProperties;
    tags?: {
        [propertyName: string]: string;
    };
}

// @public
export interface VaultPatchProperties {
    accessPolicies?: AccessPolicyEntry[];
    createMode?: CreateMode;
    enabledForDeployment?: boolean;
    enabledForDiskEncryption?: boolean;
    enabledForTemplateDeployment?: boolean;
    enablePurgeProtection?: boolean;
    enableRbacAuthorization?: boolean;
    enableSoftDelete?: boolean;
    networkAcls?: NetworkRuleSet;
    publicNetworkAccess?: string;
    sku?: Sku;
    softDeleteRetentionInDays?: number;
    tenantId?: string;
}

// @public
export interface VaultProperties {
    accessPolicies?: AccessPolicyEntry[];
    createMode?: CreateMode;
    enabledForDeployment?: boolean;
    enabledForDiskEncryption?: boolean;
    enabledForTemplateDeployment?: boolean;
    enablePurgeProtection?: boolean;
    enableRbacAuthorization?: boolean;
    enableSoftDelete?: boolean;
    readonly hsmPoolResourceId?: string;
    networkAcls?: NetworkRuleSet;
    readonly privateEndpointConnections?: PrivateEndpointConnectionItem[];
    provisioningState?: VaultProvisioningState;
    publicNetworkAccess?: string;
    sku: Sku;
    softDeleteRetentionInDays?: number;
    tenantId: string;
    vaultUri?: string;
}

// @public
export type VaultProvisioningState = string;

// @public
export interface Vaults {
    beginCreateOrUpdate(resourceGroupName: string, vaultName: string, parameters: VaultCreateOrUpdateParameters, options?: VaultsCreateOrUpdateOptionalParams): Promise<PollerLike<PollOperationState<VaultsCreateOrUpdateResponse>, VaultsCreateOrUpdateResponse>>;
    beginCreateOrUpdateAndWait(resourceGroupName: string, vaultName: string, parameters: VaultCreateOrUpdateParameters, options?: VaultsCreateOrUpdateOptionalParams): Promise<VaultsCreateOrUpdateResponse>;
    beginPurgeDeleted(vaultName: string, location: string, options?: VaultsPurgeDeletedOptionalParams): Promise<PollerLike<PollOperationState<void>, void>>;
    beginPurgeDeletedAndWait(vaultName: string, location: string, options?: VaultsPurgeDeletedOptionalParams): Promise<void>;
    checkNameAvailability(vaultName: VaultCheckNameAvailabilityParameters, options?: VaultsCheckNameAvailabilityOptionalParams): Promise<VaultsCheckNameAvailabilityResponse>;
    delete(resourceGroupName: string, vaultName: string, options?: VaultsDeleteOptionalParams): Promise<void>;
    get(resourceGroupName: string, vaultName: string, options?: VaultsGetOptionalParams): Promise<VaultsGetResponse>;
    getDeleted(vaultName: string, location: string, options?: VaultsGetDeletedOptionalParams): Promise<VaultsGetDeletedResponse>;
    list(options?: VaultsListOptionalParams): PagedAsyncIterableIterator<Resource>;
    listByResourceGroup(resourceGroupName: string, options?: VaultsListByResourceGroupOptionalParams): PagedAsyncIterableIterator<Vault>;
    listBySubscription(options?: VaultsListBySubscriptionOptionalParams): PagedAsyncIterableIterator<Vault>;
    listDeleted(options?: VaultsListDeletedOptionalParams): PagedAsyncIterableIterator<DeletedVault>;
    update(resourceGroupName: string, vaultName: string, parameters: VaultPatchParameters, options?: VaultsUpdateOptionalParams): Promise<VaultsUpdateResponse>;
    updateAccessPolicy(resourceGroupName: string, vaultName: string, operationKind: AccessPolicyUpdateKind, parameters: VaultAccessPolicyParameters, options?: VaultsUpdateAccessPolicyOptionalParams): Promise<VaultsUpdateAccessPolicyResponse>;
}

// @public
export interface VaultsCheckNameAvailabilityOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsCheckNameAvailabilityResponse = CheckNameAvailabilityResult;

// @public
export interface VaultsCreateOrUpdateOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export type VaultsCreateOrUpdateResponse = Vault;

// @public
export interface VaultsDeleteOptionalParams extends coreClient.OperationOptions {
}

// @public
export interface VaultsGetDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsGetDeletedResponse = DeletedVault;

// @public
export interface VaultsGetOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsGetResponse = Vault;

// @public
export interface VaultsListByResourceGroupNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListByResourceGroupNextResponse = VaultListResult;

// @public
export interface VaultsListByResourceGroupOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListByResourceGroupResponse = VaultListResult;

// @public
export interface VaultsListBySubscriptionNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListBySubscriptionNextResponse = VaultListResult;

// @public
export interface VaultsListBySubscriptionOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListBySubscriptionResponse = VaultListResult;

// @public
export interface VaultsListDeletedNextOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsListDeletedNextResponse = DeletedVaultListResult;

// @public
export interface VaultsListDeletedOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsListDeletedResponse = DeletedVaultListResult;

// @public
export interface VaultsListNextOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListNextResponse = ResourceListResult;

// @public
export interface VaultsListOptionalParams extends coreClient.OperationOptions {
    top?: number;
}

// @public
export type VaultsListResponse = ResourceListResult;

// @public
export interface VaultsPurgeDeletedOptionalParams extends coreClient.OperationOptions {
    resumeFrom?: string;
    updateIntervalInMs?: number;
}

// @public
export interface VaultsUpdateAccessPolicyOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsUpdateAccessPolicyResponse = VaultAccessPolicyParameters;

// @public
export interface VaultsUpdateOptionalParams extends coreClient.OperationOptions {
}

// @public
export type VaultsUpdateResponse = Vault;

// @public
export interface VirtualNetworkRule {
    id: string;
    ignoreMissingVnetServiceEndpoint?: boolean;
}

// (No @packageDocumentation comment for this package)

```
