/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { StorageManagementClient } from "@azure/arm-storage";
import { DefaultAzureCredential } from "@azure/identity";
/**
 * This sample demonstrates how to Restore a file share within a valid retention days if share soft delete is enabled
 *
 * @summary Restore a file share within a valid retention days if share soft delete is enabled
 * x-ms-original-file: specification/storage/resource-manager/Microsoft.Storage/stable/2022-09-01/examples/FileSharesRestore.json
 */
function restoreShares() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = "{subscription-id}";
        const resourceGroupName = "res3376";
        const accountName = "sto328";
        const shareName = "share1249";
        const deletedShare = {
            deletedShareName: "share1249",
            deletedShareVersion: "1234567890"
        };
        const credential = new DefaultAzureCredential();
        const client = new StorageManagementClient(credential, subscriptionId);
        const result = yield client.fileShares.restore(resourceGroupName, accountName, shareName, deletedShare);
        console.log(result);
    });
}
restoreShares().catch(console.error);
//# sourceMappingURL=fileSharesRestoreSample.js.map