/*
 * Copyright (c) Microsoft Corporation.
 * Licensed under the MIT License.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
import { __awaiter } from "tslib";
// Copyright (c) Microsoft Corporation.
// Licensed under the MIT License.
import { StorageManagementClient } from "@azure/arm-storage";
import { DefaultAzureCredential } from "@azure/identity";
/**
 * This sample demonstrates how to List SAS credentials of a storage account.
 *
 * @summary List SAS credentials of a storage account.
 * x-ms-original-file: specification/storage/resource-manager/Microsoft.Storage/stable/2022-09-01/examples/StorageAccountListAccountSAS.json
 */
function storageAccountListAccountSas() {
    return __awaiter(this, void 0, void 0, function* () {
        const subscriptionId = "{subscription-id}";
        const resourceGroupName = "res7985";
        const accountName = "sto8588";
        const parameters = {
            keyToSign: "key1",
            sharedAccessExpiryTime: new Date("2017-05-24T11:42:03.1567373Z"),
            permissions: "r",
            protocols: "https,http",
            resourceTypes: "s",
            services: "b",
            sharedAccessStartTime: new Date("2017-05-24T10:42:03.1567373Z")
        };
        const credential = new DefaultAzureCredential();
        const client = new StorageManagementClient(credential, subscriptionId);
        const result = yield client.storageAccounts.listAccountSAS(resourceGroupName, accountName, parameters);
        console.log(result);
    });
}
storageAccountListAccountSas().catch(console.error);
//# sourceMappingURL=storageAccountsListAccountSasSample.js.map